!define MUI_PRODUCT "ABC"
!define MUI_BRANDINGTEXT "ABC [ Yet Another Bittorrent Client ]"
!define MUI_VERSION "2.4.3"
!define MUI_HEADERBITMAP "${NSISDIR}\Contrib\Icons\modern-header.bmp"

!include "MUI.nsh"

!define TEMP $R0

!define MUI_FILE "ABC"

;--------------------------------
;Configuration

;General
 OutFile "${MUI_FILE}-win32-v${MUI_VERSION}.exe"

;Folder selection page
 InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"
 
;Remember install folder
 InstallDirRegKey HKCU "Software\${MUI_PRODUCT}" ""

 SetCompressor "bzip2"

;--------------------------------
;Modern UI Configuration

; !define MUI_CUSTOMPAGECOMMANDS

 !define MUI_WELCOMEPAGE
 !define MUI_LICENSEPAGE
 !define MUI_COMPONENTSPAGE
 !define MUI_DIRECTORYPAGE 
 !define MUI_ABORTWARNING
 !define MUI_UNINSTALLER
 !define MUI_UNCONFIRMPAGE
 !define MUI_FINISHPAGE

;--------------------------------
;Pages
; !insertmacro MUI_PAGE_LICENSE
;!insertmacro MUI_PAGE_COMPONENTS
; !insertmacro MUI_PAGE_DIRECTORY
; !insertmacro MUI_PAGE_INSTFILES

;--------------------------------
;Languages

 !insertmacro MUI_LANGUAGE "English"
 
;--------------------------------
;Language Strings

;Description
 LangString DESC_SecMain ${LANG_ENGLISH} "Main program files"
 LangString DESC_SecDesk ${LANG_ENGLISH} "Desktop Shortcuts"
 LangString DESC_SecStart ${LANG_ENGLISH} "StartMenu Shortcuts"
 LangString DESC_SecDefault ${LANG_ENGLISH} "Associate .torrent with ABC"
 
;Header
 LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Options"
 LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Please choose which features you wish installed"

;--------------------------------
;Data
 
 LicenseData "LICENSE.txt"

;--------------------------------
;Installer Sections

Section "!Main EXE" SecMain

 SetOutPath "$INSTDIR"
 File abc.conf
 File abc.ini 
 File LICENSE.txt
 File icon_abc.ico
 File readme.txt
 File torrent.lst 
 File announce.lst
 File ABC.exe
 File *.pyd
 File *.dll
 CreateDirectory "$INSTDIR\torrent"

 WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "DisplayName" "${MUI_PRODUCT} (remove only)"
 WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "UninstallString" "$INSTDIR\Uninstall.exe"

 WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

Section "Desktop Icons" SecDesk
   CreateShortCut "$DESKTOP\${MUI_PRODUCT}.lnk" "$INSTDIR\${MUI_PRODUCT}.exe" ""
SectionEnd

Section "Startmenu Icons" SecStart
   CreateDirectory "$SMPROGRAMS\${MUI_PRODUCT}"
   CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\Uninstall.lnk" "$INSTDIR\Uninstall.exe" "" "$INSTDIR\Uninstall.exe" 0
   CreateShortCut "$SMPROGRAMS\${MUI_PRODUCT}\${MUI_PRODUCT}.lnk" "$INSTDIR\${MUI_PRODUCT}.exe" "" "$INSTDIR\${MUI_PRODUCT}.exe" 0
SectionEnd

Section "Make Default" SecDefault
   WriteRegStr HKCR .torrent "" bittorrent
   WriteRegStr HKCR .torrent "Content Type" application/x-bittorrent
   WriteRegStr HKCR "MIME\Database\Content Type\application/x-bittorrent" Extension .torrent
   WriteRegStr HKCR bittorrent "" "TORRENT File"
   WriteRegBin HKCR bittorrent EditFlags 00000100
   WriteRegStr HKCR "bittorrent\shell" "" open
   WriteRegStr HKCR "bittorrent\shell\open\command" "" `"$INSTDIR\${MUI_PRODUCT}.exe" "%1"`
SectionEnd

;Display the Finish header
;Insert this macro after the sections if you are not using a finish page
;!insertmacro MUI_SECTIONS_FINISHHEADER

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
 !insertmacro MUI_DESCRIPTION_TEXT ${SecMain} $(DESC_SecMain)
 !insertmacro MUI_DESCRIPTION_TEXT ${SecDesk} $(DESC_SecDesk)
 !insertmacro MUI_DESCRIPTION_TEXT ${SecStart} $(DESC_SecStart)
; !insertmacro MUI_DESCRIPTION_TEXT ${SecLang} $(DESC_SecLang)
 !insertmacro MUI_DESCRIPTION_TEXT ${SecDefault} $(DESC_SecDefault)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

 Delete "$INSTDIR\*.*"
 Delete "$INSTDIR\torrent\*.*"

 RMDir "$INSTDIR\torrent"
 RMDir "$INSTDIR"

 Delete "$DESKTOP\${MUI_PRODUCT}.lnk"
 Delete "$SMPROGRAMS\${MUI_PRODUCT}\*.*"
 RmDir  "$SMPROGRAMS\${MUI_PRODUCT}"

 DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\${MUI_PRODUCT}"
 DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"

 !insertmacro MUI_UNFINISHHEADER

SectionEnd
