from sys import argv
from wxPython.wx import *
from wxPython import *
#from wxPython.lib.mixins.listctrl import wxListCtrlAutoWidthMixin
from BitTorrent import version
from BitTorrent.download import download
from threading import Event, Thread, Timer
from os.path import join
from os import getcwd, path, chdir
from BitTorrent.zurllib import urlopen
from interconn import ServerListener, ClientPassParam
from filemanager import TorrentConfigFileManager, TorrentListFileManager
from scheduler import ABCScheduler
from abcdetailframe import ABCDetailFrame
from webbrowser import open_new
from shutil import copyfile
from guimanager import GUIManager
from abc_tweak import ABCTweakFrame
from btmaketorrentgui import DownloadInfo
from aboutmedlg import AboutMeDialog
from abcoptiondlg import ABCOptionDialog
from globaluploaddlg import GlobalUploadDialog


#class ABCListCtrl(wxListCtrl, wxListCtrlAutoWidthMixin):
#    def __init__(self, parent, ID, pos=wxDefaultPosition,
#                 size=wxDefaultSize, style=0):
#        wxListCtrl.__init__(self, parent, ID, pos, size, style)
#        wxListCtrlAutoWidthMixin.__init__(self)

# Define File Drop Target class 
class FileDropTarget(wxFileDropTarget): 
   def __init__(self, obj): 
      # Initialize the wsFileDropTarget Object 
      wxFileDropTarget.__init__(self) 
      # Store the Object Reference for dropped files 
      self.obj = obj 
 
   def OnDropFiles(self, x, y, filenames): 
      for file in filenames:
            filename     = path.split(file)[1]
            torrentsrc   = path.join(self.obj.abcpath, "torrent", filename)
            try:
                f = open(torrentsrc, "r")
                f.close()
                # There is a duplicate .torrent file in /torrent
                dlg = wxMessageDialog(self.obj, "This torrent is duplicate!\nAre you sure to replace it?" , "Duplicate Torrent!", wxYES_NO|wxICON_EXCLAMATION)
                if(dlg.ShowModal() == wxID_NO):
                    dlg.Destroy()
                    continue
            except:
                # No duplicate file
                pass            
            copyfile(file, torrentsrc)
            self.obj.queue.addNewProc(torrentsrc, False)


    
class LocalSettingDialog(wxDialog):
    def __init__(self, parent, ID, title,
                 pos=wxDefaultPosition, size=wxDefaultSize,
                 style=wxDEFAULT_DIALOG_STYLE, index=0):
        
        pre = wxPreDialog()
        pre.Create(parent, ID, title, pos, size, style)
        self.this = pre.this
        
        self.parent = parent
        self.index  = index

        #Add GUI maxupload, maxupload_rate, uploadoption
        # Upload Setting
        #####################
        localinfo = parent.queue.getLocalInfo(self.index)
        loc_maxupload       = localinfo[0]
        loc_maxuploadrate   = localinfo[1]
        loc_uploadopt       = localinfo[2]
        loc_uploadtimeh     = localinfo[3]
        loc_uploadtimem     = localinfo[4]
        loc_uploadratio     = localinfo[5]

        ID_UPLOADRATE    = wxNewId()
        ID_MAXUPLOAD     = wxNewId()
        ID_MAXUPLOADSPIN = wxNewId()
        
        wxStaticBox(self,  -1,  "Upload Setting", wxPoint(10,20), wxSize(245,85))
        wxStaticText(self, -1,  "Maximum uploads:" , wxPoint(25,40))
        wxStaticText(self, -1,  "Maximum upload rate:" , wxPoint(25,65))
        wxStaticText(self, -1,  "(0 = Unlimited)" , wxPoint(135,85))
        wxStaticText(self, -1,  "KB/s" , wxPoint(182,65))

        self.maxupload   = wxTextCtrl(self, ID_MAXUPLOAD,  loc_maxupload, wxPoint(135,35),wxSize(30, -1),wxTE_READONLY|wxTE_RIGHT)
        self.uploadrate  = wxTextCtrl(self, ID_UPLOADRATE, loc_maxuploadrate, wxPoint(135,60),wxSize(40, -1))
        h = self.maxupload.GetSize().height
        self.maxuploadspin = wxSpinButton(self, ID_MAXUPLOADSPIN, wxPoint(165, 35), wxSize(h,h), wxSP_VERTICAL)
        self.maxuploadspin.SetRange(2, 100)
        self.maxuploadspin.SetValue(int(loc_maxupload))

        uploadlist = ['Unlimited upload', 'Continue upload for', 'Upload until UL/DL ratio']
        RBOX1 = wxNewId()        
        self.rb = wxRadioBox(self, RBOX1, "Upload option for completed file",
                        wxPoint(10, 115), wxSize(245, 85),
                        uploadlist, 1, wxRA_SPECIFY_COLS)
        self.rb.SetSelection(int(loc_uploadopt))

        wxStaticText(self, -1, "H", wxPoint(188,155)) # 270-155 = 115
        wxStaticText(self, -1, "M", wxPoint(236,155))
        mtimeval = ['30', '45', '60', '75']
        htimeval = []
        for i in range(0, 24):
            htimeval.append(str(i))
            
        ID_COMBOBOX_HTIME = wxNewId()
        ID_COMBOBOX_MTIME = wxNewId()
        ID_COMBOBOX_RATIO = wxNewId()

        self.cbhtime = wxComboBox(self, ID_COMBOBOX_HTIME, loc_uploadtimeh, wxPoint(150, 149),                                  
                                  wxSize(37, -1), htimeval, wxCB_DROPDOWN|wxCB_READONLY)
        self.cbmtime = wxComboBox(self, ID_COMBOBOX_MTIME, loc_uploadtimem, wxPoint(198, 149),
                                  wxSize(37, -1), mtimeval, wxCB_DROPDOWN|wxCB_READONLY)
        self.cbhtime.SetValue(loc_uploadtimeh)
        self.cbmtime.SetValue(loc_uploadtimem)

        ratioval = ['50', '75', '100', '125', '150','175','200']
        self.cbratio = wxComboBox(self, ID_COMBOBOX_RATIO, loc_uploadratio,
                                  wxPoint(150, 173), wxSize(45, -1), ratioval, wxCB_DROPDOWN|wxCB_READONLY)
        self.cbratio.SetValue(loc_uploadratio)
        wxStaticText(self, -1, "%", wxPoint(195,178))

#        self.cbsuper_seed = wxCheckBox(self, -1, "Use Super-Seed Mode (Only!! For first seed)",
#                                       wxPoint(15, 210))
        ID_APPLY_BUTTON = wxNewId()
        applybtn  = wxButton(self, ID_APPLY_BUTTON, " Apply ",  wxPoint(88, 215))
        cancelbtn = wxButton(self, wxID_CANCEL,     " Cancel ", wxPoint(178,215))

        # Add events
        ###########################
        EVT_SPIN(self, ID_MAXUPLOADSPIN, self.onMaxUploadSpin)
        EVT_BUTTON(self, ID_APPLY_BUTTON, self.onApply)

    def onMaxUploadSpin(self, event):
        self.maxupload.SetValue(str(event.GetPosition()))
            
    def onApply(self, event):
        loc_info = []
        loc_info.append(self.maxupload.GetValue())      #maxupload
        loc_info.append(self.uploadrate.GetValue())     #maxuploadrate
        loc_info.append(str(self.rb.GetSelection()))    #uploadopt     
        loc_info.append(self.cbhtime.GetValue())        #uploadtimeh   
        loc_info.append(self.cbmtime.GetValue())        #uploadtimem   
        loc_info.append(self.cbratio.GetValue())        #uploadratio

        try:
            upload_rate = int(self.uploadrate.GetValue())
        except: #not integer
            dlg = wxMessageDialog(self, "Only integer allows in Maximum upload rate setting"  , "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        if upload_rate < 3 and upload_rate != 0:
            #display warning
            dlg = wxMessageDialog(self, "Minimum upload rate is 3kB/s or 0 for unlimited upload rate"  , "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            return

        self.parent.queue.changeLocalInfo(self.index, loc_info)
        # Sent new parameter to process
        #################################
        # must change now
        # - maxupload, maxuploadrate, numsimdownload
        # - uploadoption, uploadtimeh, uploadtimem,
        # - uploadratio, removetorrent
        ##########################################
        # - minport, maxport, setdefaultfolder, defaultfolder will
        #   automatically activate with new torrent
        ##########################################
        self.Destroy()


##############################################################
# Class : ABCPanel
#
# Main ABC Panel class
############################################################## 
class ABCPanel(wxPanel):

    def __init__(self, parent, params, abcparams, abcpath, guiman):
        wxPanel.__init__(self, parent, -1, style=wxWANTS_CHARS)
        
        self.parent     = parent        
        self.params     = params
        self.abcparams  = abcparams
        self.dldlgsem   = 0
        self.abcpath    = abcpath
        self.guiman     = guiman
        
        #Manual Bittorrent Adding UI
        ##############################
        colSizer = wxFlexGridSizer(cols = 1, vgap = 4)

        spacetext = wxStaticText(self, -1, "")
        spacetext.SetFont(wxFont(1, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        colSizer.Add(spacetext, -1, wxEXPAND)
        
        firstlineSizer = wxFlexGridSizer(cols=6, vgap = 3,hgap = 3)
        colSizer.Add(firstlineSizer, -1, wxLEFT)

        firstlineSizer.Add(wxStaticText(self, -1, "  "))
        firstlineSizer.Add(wxStaticText(self, -1, "Bittorent link : "), -1, wxALIGN_CENTER)
        
        ID_BTLINK   = wxNewId()
        ID_ADDLINK  = wxNewId()
        ID_CLEARLINK=  wxNewId()

        self.TextCtrlBTLink = wxTextCtrl(self, ID_BTLINK, "", size=(260, -1))

        firstlineSizer.Add(self.TextCtrlBTLink, -1, wxALIGN_CENTER)
        firstlineSizer.Add(wxButton(self, ID_ADDLINK, "Add Link"), -1, wxALIGN_CENTER)        
        firstlineSizer.Add(wxButton(self, ID_CLEARLINK, "Clear"), -1, wxALIGN_CENTER)
        firstlineSizer.Add(wxStaticText(self, -1, ""), -1, wxALIGN_CENTER)
        firstlineSizer.AddGrowableCol(5)

        secondlineSizer = wxFlexGridSizer(cols=5, vgap = 3, hgap = 3)
        secondlineSizer.Add(wxStaticText(self, -1, "  "))        
        colSizer.Add(secondlineSizer, -1, wxLEFT)
        secondlineSizer.Add(wxStaticText(self, -1, "Bittorent file : "), -1, wxALIGN_CENTER)
        
        ID_ADDTORFROMFILE=wxNewId()
        ID_ADDNONEDEFAULT=wxNewId()
        secondlineSizer.Add(wxButton(self, ID_ADDTORFROMFILE, "Add Torrent File"))
        secondlineSizer.Add(wxButton(self, ID_ADDNONEDEFAULT, "Add Torrent File to non-default location"))
        secondlineSizer.Add(wxStaticText(self, -1, ""), -1, wxALIGN_CENTER)
        secondlineSizer.AddGrowableCol(4)

        # List Control Display UI
        ###############################
        ID_LISTCTRL = wxNewId()
        self.list = wxListCtrl(self, ID_LISTCTRL , style=wxLC_REPORT|wxLC_SINGLE_SEL)
        dragdroplist = FileDropTarget(self)
        self.list.SetDropTarget(dragdroplist)
        colSizer.Add(self.list, -1, wxEXPAND)

        # New option buttons
        ##################################
        bottomline = wxFlexGridSizer(cols=5, vgap=3, hgap=3)
        colSizer.Add(bottomline, -1, wxLEFT)

        ID_CLEARTORRENT = wxNewId()
        ID_MOVELISTUP   = wxNewId()
        ID_MOVELISTDOWN = wxNewId()
        bottomline.Add(wxStaticText(self, -1, "  "))
        bottomline.Add(wxButton(self, ID_MOVELISTUP, "Move Up"), -1, wxALIGN_CENTER)
        bottomline.Add(wxButton(self, ID_MOVELISTDOWN, "Move Down"), -1, wxALIGN_CENTER)
        bottomline.Add(wxButton(self, ID_CLEARTORRENT, "Clear all completed torrents"), -1, wxALIGN_CENTER)
        bottomline.Add(wxStaticText(self, -1, ""), -1, wxALIGN_CENTER)
        bottomline.AddGrowableCol(4)

        
        colSizer.AddGrowableRow(3)
        colSizer.AddGrowableCol(0)
        self.SetSizer(colSizer)
        self.SetAutoLayout(true)
        
        # Read abc.ini for status display
        ####################################
        for rank in range(0, self.guiman.getNumCol()):
            self.list.InsertColumn(rank, self.guiman.getTextfromRank(rank))
            self.list.SetColumnWidth(rank, self.guiman.getValuefromRank(rank))
        
        self.queue  = ABCScheduler(self, self.abcparams, self.guiman)

        # Read old list from torrent.lst
        ####################################
        torrentlistfile = TorrentListFileManager()
        torrentlistfile.open("torrent.lst")
        oldproc_array = []
        while True:
            config = torrentlistfile.readList()
            if config != ["", "", "", "", "", "", ""]: #filename, src, dest, status, prio, downsize, upsize
                oldproc_array.append([config[0], config[1], config[2], config[3], config[4], config[5], config[6]])
            else:
                if len(oldproc_array) != 0:
                    self.queue.addOldProc(oldproc_array)
                break
        # Start single instance server listenner
        ############################################
        self.serverlistener = ServerListener()
        self.serverthread   = Thread(target = self.serverlistener.start, args = [self])
        self.serverthread.setDaemon(false)
        self.serverthread.start()

        #if server start with params run it
        #####################################
        if self.params[0] != "":
            ClientPassParam(self.params[0], self.abcpath)

        # Event
        #############
        EVT_TEXT_ENTER(self, ID_BTLINK, self.AddTorrentLink)
        EVT_BUTTON(self, ID_ADDLINK, self.AddTorrentLink)
        EVT_BUTTON(self, ID_CLEARLINK, self.ClearLink) 
        EVT_BUTTON(self, ID_ADDTORFROMFILE, self.AddTorrentFile)
        EVT_BUTTON(self, ID_ADDNONEDEFAULT , self.AddTorrentNoneDefault)

        EVT_BUTTON(self, ID_CLEARTORRENT, self.onClearAllCompleted)
        EVT_BUTTON(self, ID_MOVELISTUP, self.onItemMoveUp)
        EVT_BUTTON(self, ID_MOVELISTDOWN, self.onItemMoveDown)


        EVT_LIST_ITEM_RIGHT_CLICK(self, ID_LISTCTRL, self.OnItemSelected)
        EVT_KEY_DOWN(self.list, self.IgnoreEvent)
        EVT_KEY_UP(self.list, self.IgnoreEvent)
        EVT_CHAR(self.list, self.IgnoreEvent)
        EVT_LEFT_DOWN(self.list, self.OnLeftDown)
        EVT_RIGHT_DOWN(self.list, self.OnRightDown)
        EVT_LEFT_DCLICK(self.list, self.OnLeftDClick)
        self.x = 0
        self.y = 0
        self.selectedROW = -1

    def IgnoreEvent(self, event):
        pass
    
    def OnLeftDown(self, event):
        self.x = event.GetX()
        self.y = event.GetY()
        item, flags = self.list.HitTest((self.x, self.y))
        if flags & wxLIST_HITTEST_ONITEM:
            self.selectedROW = item
            if item != -1:
                self.list.Select(item)
        event.Skip()
    
    def OnLeftDClick(self, event):
        self.x = event.GetX()
        self.y = event.GetY()
        item, flags = self.list.HitTest((self.x, self.y))
        if flags & wxLIST_HITTEST_ONITEM:
            self.selectedROW = item
            if item != -1:
                self.list.Select(item)
                self.onDetailsNoEvent()
        event.Skip()

        
    def ClearLink(self, event):
        self.TextCtrlBTLink.SetValue("")
        
    def OnRightDown(self, event):
        self.x = event.GetX()
        self.y = event.GetY()
        item, flags = self.list.HitTest((self.x, self.y))
        if flags & wxLIST_HITTEST_ONITEM:
            self.selectedROW = item
            if item != -1 :
                self.list.Select(item)
        event.Skip()

    def OnItemSelected(self, event):
        self.selectedROW = event.m_itemIndex
      
        if not hasattr(self, "popupID1"):    
            self.popupID1 = wxNewId()
            self.popupID2 = wxNewId()
            self.popupID3 = wxNewId()
            self.popupID4 = wxNewId()
            self.popupID5 = wxNewId()
            self.popupID6 = wxNewId()
            self.popupID7 = wxNewId()
            self.popupID8 = wxNewId()
            #self.popupID9  = wxNewId()
            #self.popupID10 = wxNewId()
            self.popupID11 = wxNewId()
            self.popupID12 = wxNewId()
            # Fix ID for Priority menu
            self.prioID1  = 666
            self.prioID2  = 667
            self.prioID3  = 668
            self.prioID4  = 669
            self.prioID5  = 670



            EVT_MENU(self, self.popupID1, self.onResume)
            EVT_MENU(self, self.popupID2, self.onPause)
            EVT_MENU(self, self.popupID3, self.onQueue)
            EVT_MENU(self, self.popupID4, self.onRemove)
            EVT_MENU(self, self.popupID6, self.onLocalSetting)
            EVT_MENU(self, self.popupID7, self.onSuperSeed)
            EVT_MENU(self, self.popupID8, self.onDetails)
            EVT_MENU(self, self.popupID11, self.onOpenDest)
            EVT_MENU(self, self.popupID12, self.onChangeDownloadDest)

            
            EVT_MENU(self, self.prioID1, self.onChangePrio)
            EVT_MENU(self, self.prioID2, self.onChangePrio)
            EVT_MENU(self, self.prioID3, self.onChangePrio)
            EVT_MENU(self, self.prioID4, self.onChangePrio)
            EVT_MENU(self, self.prioID5, self.onChangePrio)

        # Make a right-click menu
        ################################
        menu = wxMenu()
        menu.Append(self.popupID1, "Resume")
        menu.Append(self.popupID2, "Pause")
        menu.Append(self.popupID3, "Queue")
        menu.Append(self.popupID4, "Remove")
        menu.AppendSeparator()        


        submenu = wxMenu()
        submenu.Append(self.prioID1, "Highest", "Highest", wxITEM_RADIO)
        submenu.Append(self.prioID2, "High", "High",wxITEM_RADIO)
        submenu.Append(self.prioID3, "Normal","Normal", wxITEM_RADIO)
        submenu.Append(self.prioID4, "Low", "Low",wxITEM_RADIO)
        submenu.Append(self.prioID5, "Lowest", "Lowest",wxITEM_RADIO)
        oldprio = self.queue.getPriority(self.selectedROW)
        submenu.Check(oldprio+666, True)
        menu.Append(self.popupID6, "Local Upload Setting ...")
        menu.AppendMenu(self.popupID5, "Priority Setting", submenu)

        
        menu.AppendSeparator()
        menu.Append(self.popupID7, "Use Super-seed Mode")

        
        menu.AppendSeparator()
        menu.Append(self.popupID11, "Open Destination ...")
        menu.Append(self.popupID12, "Change Download Destination...")

        menu.AppendSeparator()                    
        menu.Append(self.popupID8, "Torrent Details ...")

        # Popup the menu.  If an item is selected then its handler
        # will be called before PopupMenu returns.
        self.PopupMenu(menu, wxPoint(self.x, self.y+40))
        #menu.Destroy() #??????


    def onOpenDest(self, event):
        relative_row = self.selectedROW
        if self.queue.isProcComplete(relative_row):
            Thread(target = open_new(self.queue.getProcDest(relative_row))).start()
        else:   #Display Warning file is not complete yet
            dlg = wxMessageDialog(self, "Your file is not complete yet\nDo you really want to open?",
                                  "Warning!!", wxYES_NO|wxICON_EXCLAMATION)
            if dlg.ShowModal() == wxID_YES:
                Thread(target = open_new(self.queue.getProcDest(relative_row))).start()            
            dlg.Destroy()
            
    def onChangeDownloadDest(self, event):
        relative_row = self.selectedROW
        if self.queue.isProcActive(relative_row): #torrent is active, error!
            dlg = wxMessageDialog(self, "Torrent is active, you have to inactivate it before change destination.",
                                  "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
        else:
            #pop-up file dialog or dir dialog for new destination
            isfile, defaultname = self.queue.isFile(relative_row)
            if isfile: #Torrent is a file open file dialog
                dl = wxFileDialog(self, 'Choose new location for this torrent', '', defaultname, '*.*', wxSAVE)                
            else :  # Torrent is a folder, open folder dialog
                dl = wxDirDialog(self, 'Choose new directory for this torrent', path.join(getcwd(), defaultname), style = wxDD_DEFAULT_STYLE | wxDD_NEW_DIR_BUTTON)
            if dl.ShowModal() == wxID_OK:
                self.queue.changeProcDest(relative_row, dl.GetPath())
        
    def onItemMoveUp(self, event):
        relative_row = self.selectedROW
        if relative_row == -1:
            return
        
        if self.queue.MoveItemUp(relative_row):
            self.list.Select(relative_row - 1)
            self.selectedROW = self.selectedROW - 1
        
    def onItemMoveDown(self, event):
        relative_row = self.selectedROW
        if relative_row == -1:
            return
        
        if self.queue.MoveItemDown(relative_row):
            self.list.Select(relative_row + 1)
            self.selectedROW = self.selectedROW + 1

    def onClearAllCompleted(self, event):
        relative_row = self.selectedROW
        # Deselect List
        self.list.SetItemState(relative_row, 0, wxLIST_STATE_SELECTED)
        # Clear all completed torrent
        self.queue.clearAllCompleted()
        self.selectedROW = -1

    def onSuperSeed(self, event):
        relative_row = self.selectedROW
        self.queue.procSUPERSEED(relative_row)

    def onResume(self, event):
        relative_row = self.selectedROW
        self.queue.procRESUME(relative_row)
        
    def onPause(self, event):
        relative_row = self.selectedROW
        self.queue.procPAUSE(relative_row)
        # change display status in list control
        ###############################################
        # 0:Title, 3:Priority, 12:%U/D 18:downsize, 19:upsize-> don't have to change
        ###############################################
        for rank in range (0, self.guiman.getNumCol()):
            colid = self.guiman.getIDfromRank(rank)            
            if colid != 4 and colid != 7 and colid != 12 and colid != 18 and colid != 19:   
                if colid == 6:              # change bt status to pause
                    self.list.SetStringItem(relative_row, rank, "pause")
                else:
                    self.list.SetStringItem(relative_row, rank, "")

    def onQueue(self, event):
        relative_row = self.selectedROW
        self.queue.procQUEUE(relative_row, 0)
        # change display status in list control
        ###############################################
        # 0:Title, 3:Priority, 12:%U/D 18:downsize, 19:upsize-> don't have to change
        ###############################################
        for rank in range (0, self.guiman.getNumCol()):
            colid = self.guiman.getIDfromRank(rank)
            
            if colid != 4 and colid != 7 and colid != 12 and colid != 18 and colid != 19:   
                if colid == 6:              # change bt status to pause
                    self.list.SetStringItem(relative_row, rank, "queue")
                else:
                    self.list.SetStringItem(relative_row, rank, "")

    def onRemove(self, event):
        relative_row = self.selectedROW
        self.list.DeleteItem(relative_row)
        self.queue.procREMOVE(relative_row)
        self.selectedROW = -1

        
    def onChangePrio(self, event):
        prio = (event.GetId()) - 666
        relative_row = self.selectedROW
        self.queue.changePriority(relative_row, prio)

        rank = self.guiman.getRankfromID(7) #priority id = 7
        if rank != -1:
            self.list.SetStringItem(relative_row, rank, self.queue.priotext[prio])            
        #self.list.SetStringItem(relative_row, 3, self.queue.priotext[prio])            
        
    def onLocalSetting(self, event):
        relative_row = self.selectedROW
        localsettingdlg = LocalSettingDialog(self, -1, "Local Setting", size=wxSize(275, 300),
                          style = wxDEFAULT_DIALOG_STYLE, index=relative_row)
        localsettingdlg.ShowModal()

    def onDetailsNoEvent(self):
        relative_row = self.selectedROW
        if (self.queue.hasDetailWin(relative_row)):
            self.queue.proctab[relative_row][14].killAdv()

        self.queue.proctab[relative_row][14] = ABCDetailFrame(self, -1, "Torrent Details", self.abcpath, self.queue.proctab[relative_row][2], relative_row, wxSize(self.guiman.getValue(2), self.guiman.getValue(3)))
        if self.queue.proctab[relative_row][1] is not None:
            self.queue.proctab[relative_row][1].detailwin = self.queue.proctab[relative_row][14]
        
    def onDetails(self, event):
        self.onDetailsNoEvent()
            

    def AddTorrentLink(self, event):
        self.btlink = str(self.TextCtrlBTLink.GetValue())
        if self.btlink[:7] != "http://":
            dlg = wxMessageDialog(self, "Please enter URL started with http://",
                                  "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
        else:
            # Copy file from web and call addnewproc
            #########################################
            try:
                h = urlopen(self.btlink)
                btmetafile = h.read()
                h.close()
            except IOError, e:
                #display error can't connect to server
                dlg = wxMessageDialog(self, "Can't get torrent from this URL",
                                  "Error!!", wxICON_ERROR)
                dlg.ShowModal()
                dlg.Destroy()
                return

            # Backup metainfo from URL to local directory
            filename = path.split(self.btlink)[1]
            torrentsrc = path.join(self.abcpath, "torrent", filename)
            try:
                f = open(torrentsrc, "r")
                f.close()
                # There is a duplicate .torrent file in /torrent
                dlg = wxMessageDialog(self, "This torrent is duplicate!\nAre you sure to replace it?" , "Duplicate Torrent!", wxYES_NO|wxICON_EXCLAMATION)
                if(dlg.ShowModal() == wxID_NO):
                    dlg.Destroy()
                    return
            except:
                # No duplicate file
                pass
            f = open(torrentsrc, "wb")
            f.write(btmetafile)
            f.close()
            self.queue.addNewProc(torrentsrc, False)
            

    def AddTorrentFile(self, event):
        dl = wxFileDialog(self, 'Choose a torrent file', '', '', '*.torrent', wxOPEN|wxMULTIPLE)
        if dl.ShowModal() != wxID_OK:
            dl.Destroy()
            return
        
        filelocation = dl.GetPaths()
        for i in range (0, len(filelocation)):            
            filename     = path.split(filelocation[i])[1]
            torrentsrc   = path.join(self.abcpath, "torrent", filename)
            try:
                f = open(torrentsrc, "r")
                f.close()
                # There is a duplicate .torrent file in /torrent
                dlg = wxMessageDialog(self, "This torrent is duplicate!\nAre you sure to replace it?" , "Duplicate Torrent!", wxYES_NO|wxICON_EXCLAMATION)
                if(dlg.ShowModal() == wxID_NO):
                    dlg.Destroy()
                    continue
            except:
                # No duplicate file
                pass
            copyfile(filelocation[i], torrentsrc)
            self.queue.addNewProc(torrentsrc, False)
        
    def AddTorrentNoneDefault(self, event):
        dl = wxFileDialog(self, 'Choose a torrent file', '', '', '*.torrent', wxOPEN|wxMULTIPLE)
        if dl.ShowModal() != wxID_OK:
            dl.Destroy()
            return
        
        filelocation = dl.GetPaths()
        for i in range (0, len(filelocation)):            
            filename     = path.split(filelocation[i])[1]
            torrentsrc   = path.join(self.abcpath, "torrent", filename)
            try:
                f = open(torrentsrc, "r")
                f.close()
                # There is a duplicate .torrent file in /torrent
                dlg = wxMessageDialog(self, "This torrent is duplicate!\nAre you sure to replace it?" , "Duplicate Torrent!", wxYES_NO|wxICON_EXCLAMATION)
                if(dlg.ShowModal() == wxID_NO):
                    dlg.Destroy()
                    continue
            except:
                # No duplicate file
                pass
            copyfile(filelocation[i], torrentsrc)
            self.queue.addNewProc(torrentsrc, True)





    def changeABCParams(self, abcparams):
        self.abcparams = abcparams
        self.queue.changeABCParams(self.abcparams)

    def closeAllThread(self):
        self.queue.clearScheduler()

##############################################################
# Class : ABCFrame
#
# Main ABC Frame class that contains menu and menu bar management
# and contains ABCPanel
#
############################################################## 
class ABCFrame(wxFrame):
    def __init__(self, parent, ID, title, params, abcpath):
        self.guiman = GUIManager(abcpath)
        app_width  = self.guiman.getValue(0) # ID: 0 = App_Width
        app_height = self.guiman.getValue(1) # ID: 1 = App_Height
        
        wxFrame.__init__(self, parent, ID, title, wxDefaultPosition, wxSize(app_width,app_height))
        
        self.params = params
        self.abcparams = {}
        self.configchange = 0
        self.abcpath = abcpath
        self.abctweak = None
        self.maketorrent = None
        
        self.CreateStatusBar()
        self.SetStatusText("")

        if (sys.platform == 'win32'):
            self.icon = wxIcon(path.join(abcpath, 'icon_abc.ico'), wxBITMAP_TYPE_ICO)
            self.SetIcon(self.icon)

        # Menu Options
        ############################
        ID_ABC_OPTION   = wxNewId()
        ID_ABOUT        = wxNewId()
        ID_EXIT         = wxNewId()
        ID_ABC_TWEAK    = wxNewId()
        ID_GLOBAL_UPLOAD= wxNewId()
        ID_MAKETORRENT  = wxNewId()
        ID_LASTESTVERSION   = wxNewId()
        self.TBMENU_RESTORE = wxNewId()
        self.TBMENU_CLOSE   = wxNewId()

        
        menu = wxMenu()
        menu.Append(ID_ABC_OPTION, "&ABC Preference", "Set ABC preference")
        menu.Append(ID_GLOBAL_UPLOAD, "&Global Upload Setting", "Setting global upload value")
        menu.AppendSeparator()
        menu.Append(ID_EXIT, "&Exit", "Close Program")


        menutool = wxMenu()
        menutool.Append(ID_ABC_TWEAK, "&ABC Tweak", "Running ABC Tweak")
        menutool.Append(ID_MAKETORRENT, "&Make Torrent", "Make .torrent file")

        menuadv = wxMenu()
        menuadv.Append(ID_LASTESTVERSION, "&Check Lastest Version", "Check Lastest Version")
        menuadv.Append(ID_ABOUT, "&About ABC", "See Credit")

        menuBar = wxMenuBar()        
        menuBar.Append(menu, "&Action")
        menuBar.Append(menutool, "&Tools")
        menuBar.Append(menuadv, "&Version")
        self.SetMenuBar(menuBar)


        # Read ABC config file
        ##############################
        abcconfigfile = TorrentConfigFileManager()
        abcconfigfile.open(path.join(self.abcpath, "abc.conf"))
        while True:
            params = abcconfigfile.readConfig()
            if params != ["", ""]:
                self.abcparams[params[0]] = params[1]
            else:
                break
        abcconfigfile.close()
        
        self.window = ABCPanel(self, self.params, self.abcparams, self.abcpath, self.guiman) 

        # Menu Events 
        ############################
        EVT_MENU(self, ID_ABC_OPTION, self.OnMenuABCOption)
        EVT_MENU(self, ID_ABOUT, self.OnMenuAbout) 
        EVT_MENU(self, ID_ABC_TWEAK, self.OnMenuTweak)
        EVT_MENU(self, ID_GLOBAL_UPLOAD, self.OnGlobalUpload)
        EVT_MENU(self, ID_EXIT,  self.OnMenuExit)
        EVT_MENU(self, ID_MAKETORRENT, self.OnMakeTorrent)
        EVT_MENU(self, ID_LASTESTVERSION,  self.OnCheckLastestVersion)

        EVT_CLOSE(self, self.OnMenuExit)

        if(sys.platform == 'win32'):
            EVT_ICONIZE(self, self.onIconify)

   
    def OnMakeTorrent(self, event):
        self.maketorrent = DownloadInfo(self, self.abcpath)
        self.maketorrent.frame.Show(true)
        #self.SetTopWindow(d.frame)

    def OnGlobalUpload(self, event):
        abcglobupdlg = GlobalUploadDialog(self, -1, "Global Upload Setting",size=wxSize(273, 280),
                                       style = wxDEFAULT_DIALOG_STYLE)
        abcglobupdlg.ShowModal()

        
    #def OnMenuMisc(self, event):
    #    abcmiscdlg = ABCMiscDialog(self, -1, "Misc Setting",size=wxSize(295, 160),
    #                                   style = wxDEFAULT_DIALOG_STYLE)
    #    abcmiscdlg.ShowModal()
        
    def OnCheckLastestVersion(self, event):
        txtcontent = ""
        try :
            h = urlopen('http://pingpong-abc.sourceforge.net/lastest_version.txt')
            txtcontent = h.read()
            h.close()
            dlg = wxMessageDialog(self, txtcontent , "ABC Lasetest version", wxOK|wxICON_INFORMATION)
            dlg.ShowModal()
            dlg.Destroy()

        except :
            dlg = wxMessageDialog(self, "Can't connect to web server\nMaybe web server is down"  , "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()

    def PopFrameUp(self):
        if self.IsIconized():
            self.Iconize(false)
        if not self.IsShown():
            self.Show(true)
        self.Raise()
        if hasattr(self, "tbicon"):
            del self.tbicon
        return

    def onIconify(self, evt):
        if self.abcparams['mintray'] == "1":
            if not hasattr(self, "tbicon"):
                self.tbicon = wxTaskBarIcon()
                self.tbicon.SetIcon(self.icon, "ABC [Yet Another Bittorrent Client]")
            
                # setup a taskbar icon, and catch some events from it
                EVT_TASKBAR_LEFT_DCLICK(self.tbicon, self.onTaskBarActivate)
                EVT_TASKBAR_RIGHT_UP(self.tbicon, self.onTaskBarMenu)
                EVT_MENU(self.tbicon, self.TBMENU_RESTORE, self.onTaskBarActivate)
                EVT_MENU(self.tbicon, self.TBMENU_CLOSE, self.OnMenuExit)
                self.Hide()
            else:
                self.Iconize(1)
        else:
            if evt.Iconized():
                self.Iconize(1)
            else:
                self.Iconize(0)

    def onTaskBarActivate(self, evt):
        if self.IsIconized():
            self.Iconize(false)
        if not self.IsShown():
            self.Show(true)
        self.Raise()
        if hasattr(self, "tbicon"):
            del self.tbicon
        return

        

    def onTaskBarMenu(self, evt):
        menu = wxMenu()
        menu.Append(self.TBMENU_RESTORE, "Show ABC Window")
        menu.Append(self.TBMENU_CLOSE,   "Close")
        self.tbicon.PopupMenu(menu)
        menu.Destroy()
        
    ################################
    # Display ABC Option Dialog
    ################################
    def OnMenuABCOption(self, event):
        abcoptiondlg = ABCOptionDialog(self, -1, "ABC Preference",size=wxSize(295, 320),
                                       style = wxDEFAULT_DIALOG_STYLE)
        abcoptiondlg.ShowModal()
        
    ################################
    # Running ABC Tweak
    ################################
    def OnMenuTweak(self, event):
        if self.abctweak is not None:
            self.abctweak.OnExit()
        self.abctweak = ABCTweakFrame(self, -1, "ABC Tweak", self.abcpath)
        self.abctweak.Show(true)

    ################################
    # Display About me Dialog
    ################################
    def OnMenuAbout(self, event):
       aboutmedlg = AboutMeDialog(self, -1, "About ABC", size=wxSize(340, 240),
                     style = wxDEFAULT_DIALOG_STYLE)
       aboutmedlg.ShowModal()
       aboutmedlg.Destroy()
       
    ##################################
    # Close Program
    ##################################
    def OnMenuExit(self, event):
        dlg = wxMessageDialog(self, "Do you want to close ABC ?", "Confirm", wxOK|wxCANCEL)
        if dlg.ShowModal() != wxID_OK:
            return
        else:
            if self.IsIconized():
                self.Iconize(false)
            self.Raise()
            if hasattr(self, "tbicon"):
                del self.tbicon            
            # tell scheduler to close all active thread
            self.window.closeAllThread()
            if self.abctweak is not None:
                self.abctweak.OnExit()
            self.Destroy()
        
    ######################################
    # Update ABC on-the-fly
    ######################################
    def updateABCDisplay(self):
        # Reload INI
        old_numcol = self.guiman.getNumCol()
        self.guiman.reloadINI()        

        # Update App width, height
        self.SetSize(wxSize(self.guiman.getValue(0), self.guiman.getValue(1)))        
        # Update Detail width, height
        self.window.queue.SetDetailWinSize(wxSize(self.guiman.getValue(2), self.guiman.getValue(3)))

        # Update Column name and width add, delete
        #################################################
        # Delete Old Column
        #################################################
        for i in range(0, old_numcol):
            self.window.list.DeleteColumn(0)
        for rank in range(0, self.guiman.getNumCol()):
            self.window.list.InsertColumn(rank, self.guiman.getTextfromRank(rank))
            self.window.list.SetColumnWidth(rank, self.guiman.getValuefromRank(rank))

        # Update display in column for inactive torrent
        self.window.queue.updateInactiveCol()

##############################################################
# Class : ABCApp
#
# Main ABC application class that contains ABCFrame Object
#
##############################################################
class ABCApp(wxApp):
    def __init__(self, x , params, single_instance_checker, abcpath):
        self.params = params
        self.single_instance_checker = single_instance_checker
        self.abcpath = abcpath
        wxApp.__init__(self, x)

    def OnInit(self):
        frame = ABCFrame(NULL, -1, "ABC [Yet Another Bittorrent Client] 2.4.3",
                         self.params, self.abcpath)
        frame.Show(true)
        return true

        
    def OnExit(self):
        del self.single_instance_checker
        ClientPassParam("Please close connection!!", self.abcpath)
        return 0


    
##############################################################
#
# Main Program Start Here
#
##############################################################
def run(params, abcpath):
    # Create single instance semaphore
    single_instance_checker = wxSingleInstanceChecker("pingpong-abc" + str(wxGetUserId))
    
    if single_instance_checker.IsAnotherRunning():            
        #Send  torrent info to abc single instance
        #if params[0] != "":
        ClientPassParam(params[0], abcpath)
    else:
        # Launch first abc single instance
        app = ABCApp(0, params, single_instance_checker, abcpath)
        app.MainLoop()
        
if __name__ == '__main__':    
    abcpath = path.abspath(path.dirname(argv[0]))
    chdir(abcpath)

    if len(argv) == 1:
        run([""], abcpath)
    else:
        run(argv[1:], abcpath)
    

