from wxPython.wx import *
from wxPython import *
from BitTorrent.download import *
from BitTorrent.zurllib import urlopen
from threading import Event, Thread, Timer
from os.path import join
from os import getcwd
from time import strftime
from getscrapedata import getScrapeData

#from BitTorrent.bencode import *
#from BitTorrent.zurllib import urlopen
#from sha import sha
#import re


def hours(n):
    if n == -1:
        return '<unknown>'
    if n == 0:
        return ''
    n = int(n)
    h, r = divmod(n, 60 * 60)
    m, sec = divmod(r, 60)
    if h > 1000000:
        return '<unknown>'
    if h > 0:
        return '%d:%02d:%02d' % (h, m, sec)
    else:
        return '%02d:%02d' % (m, sec)

wxEVT_INVOKE = wxNewEventType()

def EVT_INVOKE(win, func):
    win.Connect(-1, -1, wxEVT_INVOKE, func)
    
def DELEVT_INVOKE(win):
    win.Disconnect(-1, -1, wxEVT_INVOKE)


    
class InvokeEvent(wxPyEvent):
    def __init__(self, func, args, kwargs):
        wxPyEvent.__init__(self)
        self.SetEventType(wxEVT_INVOKE)
        self.func = func
        self.args = args
        self.kwargs = kwargs


class ABCEngine(wxEvtHandler):
    def __init__(self, parent, listid, firsttime_flag, flag, prio, guiman, olddownsize, oldupsize):   #pos = map position of thread in CtrlList
        wxEvtHandler.__init__(self)
        self.guiman = guiman
        self.prio   = prio
        self.listid = listid
        self.parent = parent
        self.list   = parent.list
        self.firsttime_flag = firsttime_flag
        self.flag = flag
        self.errormsg = ""
        self.fileDestPath = ""
        self.fin = false
        self.iscancel = True
        self.config = None
        self.timer  = None
        self.shareratio = 0
        self.detailwin = None
        self.spewwait = time()
        self.superseed = false
        self.reannouncelast = 0
        self.lastexternalannounce = ''
        self.olddownsize = olddownsize
        self.oldupsize   = oldupsize
        self.newdownsize = 0
        self.newupsize   = 0
        self.lastgetscrape = 0            # V.2.3.1 add current, seed,peer display
        self.currentpeer = "0"
        self.currentseed = "0"
    
        EVT_INVOKE(self, self.onInvoke)

    def onInvoke(self, event):
        if not self.flag.isSet():
            event.func(*event.args, **event.kwargs)
    def invokeLater(self, func, args = [], kwargs = {}):
        if not self.flag.isSet():
            wxPostEvent(self, InvokeEvent(func, args, kwargs))

    def updateStatus(self, fractionDone = None,
            timeEst = None, downRate = None, upRate = None,
            activity = None, statistics = None, spew = None, sizeDone = None,
            **kws):
        self.invokeLater(self.onUpdateStatus, [fractionDone, timeEst, downRate, upRate, activity, statistics, spew, sizeDone])

    def getDownUpSize(self):
        return (self.olddownsize + self.newdownsize), (self.oldupsize + self.newupsize)
    
    def onUpdateStatus(self, fractionDone, timeEst, downRate, upRate, activity, statistics, spew, sizeDone):
            # V 2.3.1 add get scrape data every 20 minutes
            if (statistics is not None) and ((time() - self.lastgetscrape) > 1200):
                Thread(target = getScrapeData, args=[self.parent.getResponse(self.listid),
                                                     self]).start()
                   
                self.lastgetscrape = time()    

        
            for rank in range(0, self.guiman.getNumCol()):
                colid = self.guiman.getIDfromRank(rank)
                
                if  colid == 4   :  # Title
                    self.list.SetStringItem(self.listid, rank, self.filename)
                elif colid == 5 :   # Progress
                    if fractionDone is not None and not self.fin:
                        self.list.SetStringItem(self.listid, rank, ('%.1f' % (float(fractionDone) * 100)) + "%")
                elif colid == 6:    # Status
                    if timeEst is not None and not self.fin:
                        self.list.SetStringItem(self.listid, rank, "working")
                    else:
                        if activity is not None and not self.fin:
                            self.list.SetStringItem(self.listid, rank, activity)
                elif colid == 7 :   # Priority
                    self.list.SetStringItem(self.listid, rank, self.parent.priotext[self.prio])
                elif colid == 8:    #Time Remaining            
                    if timeEst is not None and not self.fin:
                        self.list.SetStringItem(self.listid, rank, hours(timeEst))  
                elif colid == 9 :   # Total Size
                    self.list.SetStringItem(self.listid, rank, self.totalsize)                         

                elif colid == 10:   # DL Speed
                    if downRate is not None and not self.fin:
                        self.list.SetStringItem(self.listid, rank, ('%.1f Kb/s'%(float(downRate)/(1 <<10))))
                        
                elif colid == 11:   # UL Speed
                    if upRate is not None:
                        self.list.SetStringItem(self.listid, rank, ('%.1f Kb/s'%(float(upRate)/(1 <<10))))

                elif colid == 12:   # Share Ratio
                    if statistics is not None:
                        if self.olddownsize + float(statistics.downTotal) == 0:
                            self.list.SetStringItem(self.listid, rank, " oo %")
                            self.shareratio = float(55555)
                        else:
                            self.shareratio = float(((self.oldupsize + float(statistics.upTotal))/(self.olddownsize + float(statistics.downTotal)))*100)
                            self.list.SetStringItem(self.listid, rank, ('%.1f'% self.shareratio)+ "%")
                elif colid == 13:   # Error message
                    self.list.SetStringItem(self.listid, rank, self.errormsg)
                elif colid == 14:   # #Seed
                    if statistics is not None:
                        if not self.fin:
                            self.list.SetStringItem(self.listid, rank, ('%d' % statistics.numSeeds) + ' (' + self.currentseed + ')')
                        else:
                            self.list.SetStringItem(self.listid, rank, ('%d' % statistics.numOldSeeds))

                elif colid == 15:   # #Peer
                    if statistics is not None:
                        self.list.SetStringItem(self.listid, rank, ('%d' % statistics.numPeers) + ' (' + self.currentpeer + ')')

                elif colid == 16:   # #Copie
                    if statistics is not None:
                        self.list.SetStringItem(self.listid, rank, ('%.3f' % float(0.001*int(1000*statistics.numCopies))))

                elif colid == 17:   # #Peer Avg Progress
                    if statistics is not None:
                        self.list.SetStringItem(self.listid, rank, ('%.1f %%'%statistics.percentDone))

                elif colid == 18:   # Download Size
                    if statistics is not None:
                        self.list.SetStringItem(self.listid, rank, ('%.2f MB' % ((float(self.olddownsize)+float(statistics.downTotal)) / (1 << 20))))

                elif colid == 19:   # Upload Size
                    if statistics is not None:
                        self.list.SetStringItem(self.listid, rank, ('%.2f MB' % ((float(self.oldupsize)+ float(statistics.upTotal)) / (1 << 20))))
                        
                elif colid == 20:   # Total Speed
                    if statistics is not None:
                        self.list.SetStringItem(self.listid, rank, ('%.0f kB/s' % (float(statistics.torrentRate)/(1000))))

            if statistics is not None:
                self.newdownsize = float(statistics.downTotal)
                self.newupsize   = float(statistics.upTotal)
                if self.olddownsize + float(statistics.downTotal) == 0:
                    self.shareratio = float(55555)
                else:
                    self.shareratio = float(((self.oldupsize + float(statistics.upTotal))/(self.olddownsize + float(statistics.downTotal)))*100)

            #####################################################
            # Detail Window display part
            #####################################################
            if self.parent.proctab[self.listid][14] is not None:
                self.detailwin = self.parent.proctab[self.listid][14]
                if statistics is not None:
                    self.detailwin.downsize.SetLabel('%.2f MB' % ((float(self.olddownsize) + float(statistics.downTotal)) / (1 << 20)))
                    self.detailwin.upsize.SetLabel('%.2f MB' % ((float(self.oldupsize)+ float(statistics.upTotal)) / (1 << 20)))
                    if not self.fin:
                        self.detailwin.seedtitle.SetLabel('# Connected seed')
                        self.detailwin.numseed.SetLabel(('%d' % statistics.numSeeds) + ' (' + self.currentseed + ')')
                    else:
                        self.detailwin.seedtitle.SetLabel('# Seen seed')
                        self.detailwin.numseed.SetLabel(('%d' % statistics.numOldSeeds)+ ' (' + self.currentseed + ')')
                    self.detailwin.numpeer.SetLabel(('%d' % statistics.numPeers) + ' (' + self.currentpeer + ')')
                    self.detailwin.totalspeed.SetLabel('%.0f kB/s' % (float(statistics.torrentRate)/(1000)))
                    self.detailwin.avgprogress.SetLabel('%.1f %%'%statistics.percentDone)
                    self.detailwin.numcopy.SetLabel('%.3f' % float(0.001*int(1000*statistics.numCopies)))
                    
                if self.dow.storagewrapper is not None:
                    self.detailwin.storagestats1.SetLabel(
                        '          currently downloading %d pieces (%d just started), %d pieces partially retrieved'
                                        % ( len(self.dow.storagewrapper.stat_active),
                                            len(self.dow.storagewrapper.stat_new),
                                            len(self.dow.storagewrapper.dirty)  ) )
                    self.detailwin.storagestats2.SetLabel(
                        '          %d of %d pieces complete (%d just downloaded), %d failed hash check'
                                        % ( self.dow.storagewrapper.stat_numfound +
                                            self.dow.storagewrapper.stat_numdownloaded,
                                            len(self.dow.storagewrapper.hashes),
                                            self.dow.storagewrapper.stat_numdownloaded,
                                            self.dow.storagewrapper.stat_numflunked ) )



                if spew is not None and (time() - self.spewwait > 1):
                    self.spewwait = time()
                    spewList = self.detailwin.spewList
                    if (spewList.GetItemCount()-len(spew)) < 0:
                        for x in range(len(spew)-spewList.GetItemCount()):
                            spewList.InsertStringItem(x,'')
                    if (spewList.GetItemCount()-len(spew)) > 0:
                        for x in range(spewList.GetItemCount()-len(spew)):
                            spewList.SetStringItem((len(spew))+x, 0, '')
                            spewList.SetStringItem((len(spew))+x, 1, '')
                            spewList.SetStringItem((len(spew))+x, 2, '')
                            spewList.SetStringItem((len(spew))+x, 3, '')
                            spewList.SetStringItem((len(spew))+x, 4, '')
                            spewList.SetStringItem((len(spew))+x, 5, '')
                            spewList.SetStringItem((len(spew))+x, 6, '')
                            spewList.SetStringItem((len(spew))+x, 7, '')
                            spewList.SetStringItem((len(spew))+x, 8, '')
                            spewList.SetStringItem((len(spew))+x, 9, '')
                            spewList.SetStringItem((len(spew))+x, 10, '')
                            spewList.SetStringItem((len(spew))+x, 11, '')
                            spewList.SetStringItem((len(spew))+x, 12, '')
                            spewList.SetStringItem((len(spew))+x, 13, '')

                    for x in range(len(spew)):
                        if (spew[x]['optimistic'] == 1):
                            a = '*'
                        else:
                            a = ' '
                        spewList.SetStringItem(x, 0, a)
                        spewList.SetStringItem(x, 1, spew[x]['ip'])
                        spewList.SetStringItem(x, 2, spew[x]['direction'])
                        if spew[x]['uprate'] > 100:
                            spewList.SetStringItem(x, 3, '%.0f kB/s' % (float(spew[x]['uprate']) / 1000))
                        else:
                            spewList.SetStringItem(x, 3, '')
                        if (spew[x]['uinterested'] == 1):
                            a = '*'
                        else:
                            a = ' '
                        spewList.SetStringItem(x, 4, a)
                        if (spew[x]['uchoked'] == 1):
                            a = '*'
                        else:
                            a = ' '
                        spewList.SetStringItem(x, 5, a)
                        spewList.SetStringItem(x, 6, '%.0f kB/s' % (float(spew[x]['downrate']) / 1000))
                        if (spew[x]['dinterested'] == 1):
                            a = '*'
                        else:
                            a = ' '
                        spewList.SetStringItem(x, 7, a)
                        if (spew[x]['dchoked'] == 1):
                            a = '*'
                        else:
                            a = ' '
                        spewList.SetStringItem(x, 8, a)
                        if (spew[x]['snubbed'] == 1):
                            a = '*'
                        else:
                            a = ' '
                        spewList.SetStringItem(x, 9, a)
                        spewList.SetStringItem(x, 10, '%.2f MiB' % (float(spew[x]['dtotal']) / (1 << 20)))
                        spewList.SetStringItem(x, 11, '%.2f MiB' % (float(spew[x]['utotal']) / (1 << 20)))
                        spewList.SetStringItem(x, 12, '%.1f%%' % (float(int(spew[x]['completed']*1000)/10)))
                        spewList.SetStringItem(x, 13, '%.0f kB/s' % (float(spew[x]['speed']) / 1000))   
            if self.fin and int(self.parent.proctab[self.listid][10]) == 2 and self.shareratio >= float(self.parent.proctab[self.listid][13]):
                self.invokeLater(self.TerminateUpload)

            

    def finished(self):        
        self.fin = true
        self.invokeLater(self.onFinishEvent)
        
    def failed(self):
        self.fin = true
        if self.flag.isSet():
            self.onFailEvent()            
        else:
            self.invokeLater(self.onFailEvent)

    def error(self, errormsg):
        self.errormsg = strftime('%I:%M %p -') + errormsg
        self.errortxt = errormsg


    def TerminateUpload(self):
        # Terminate process
        ####################################################
        # change:   5:Progress  6:BT Status
        # untouch:  4:Title 7:Priority 9:Size 12:%U/DSize
        #           18:DownloadSize 19:UploadSize
        # clear : 8:ETA 10:DLSpeed 11:ULspeed 13:Error message
        #         14:#seed 15:#peer 16:#copie 17:peer avg
        #         20:total speed
        #####################################################
        for rank in range(0, self.guiman.getNumCol()):
            colid = self.guiman.getIDfromRank(rank)
            if colid == 4 or colid == 7 or colid == 9 or colid == 12 or colid == 18 or colid == 19:
                continue            
            elif colid == 5:   #progress
                self.list.SetStringItem(self.listid, rank, "100%")
            elif colid == 6:   #Status
                self.list.SetStringItem(self.listid, rank, "completed")
            else:
                self.list.SetStringItem(self.listid, rank, "")
                
        self.parent.procDONE(self.listid)

    def onFinishEvent(self):
        # seeding process
        ####################################################
        # change:   5:Progress  6:BT Status
        # untouch:  4:Title 7:Priority 9:Size 12:%U/DSize
        #           18:DownloadSize 19:UploadSize 11:ULspeed
        #           13:Error message
        #           14:#seed 15:#peer 16:#copie 17:peer avg
        #           20:total speed
        #
        # clear : 8:ETA 10:DLSpeed  
        #         
        #####################################################
        for rank in range(0, self.guiman.getNumCol()):
            colid = self.guiman.getIDfromRank(rank)
            if colid == 8 or colid == 10:
                self.list.SetStringItem(self.listid, rank, "")
            elif colid == 5:
                self.list.SetStringItem(self.listid, rank, "100%")
            elif colid == 6:
                self.list.SetStringItem(self.listid, rank, "completed/seeding")

        self.parent.procFINISH(self.listid)
        uploadopt = int(self.parent.proctab[self.listid][10])
        if uploadopt == 0:      #unlimited upload
            return
        elif uploadopt == 1:    #upload with timer
            uploadtimeh = self.parent.proctab[self.listid][11]
            uploadtimem = self.parent.proctab[self.listid][12]
            uploadtimes = (int(uploadtimeh)*3600) + (int(uploadtimem)*60)
            self.timer = Timer(uploadtimes, self.TerminateUpload)
            self.timer.start()
        else:                   #upload with ratio, must check at updatestatus also
            uploadratio = float(self.parent.proctab[self.listid][13])
            if self.shareratio >= uploadratio:
                self.invokeLater(self.TerminateUpload)
            
    def onFailEvent(self):
        
        #dlg = wxMessageDialog(self.parent.parent, self.errormsg + "\n this torrent will be deleted from list now"  , "Error!!", wxICON_ERROR)
        dlg = wxMessageDialog(self.parent.parent, self.errormsg + "\n\n This torrent will be set in pause state now"  , "Error!!", wxOK|wxICON_ERROR)
        if(dlg.ShowModal() == wxID_OK):
            dlg.Destroy()
        #self.parent.list.DeleteItem(self.listid)
        #self.parent.procREMOVE(self.listid)

            self.parent.procPAUSE(self.listid)
            for rank in range (0, self.guiman.getNumCol()):
                colid = self.guiman.getIDfromRank(rank)            
                if colid != 4 and colid != 7 and colid != 12 and colid != 18 and colid != 19:   
                    if colid == 6:              # change bt status to pause
                        self.list.SetStringItem(self.listid, rank, "pause")
                    else:
                        self.list.SetStringItem(self.listid, rank, "")

            
    def chooseFile(self, default, size, saveas, dir):
        if saveas != '':        #new proc set default folder or old proc active
            bucket = [None]
            self.filename = default
            self.totalsize = ('%.1f MB' % (float(size) / (1 << 20)))
            bucket[0] = saveas            
        return bucket[0]
    
    def newpath(self, path):
        self.fileDestPath = path

    def changeIndex(self, newindex):
        self.listid = newindex
    def changeDoneFlag(self, doneflag):
        self.flag = doneflag
    def changePrio(self, newprio):
        self.prio = newprio
        
    def done(self, event):
        self.flag.set()
        DELEVT_INVOKE(self)
        if self.timer != None :
            self.timer.cancel()
