class TorrentConfigFileManager:
    def __init__(self):
        self.filename = ""
        self.f = None
        self.dic = {}
        
    def open(self, filename="abc.conf", mode="r+"):
        self.filename = filename
        self.f = open(self.filename, mode)

    def readConfig(self):
        configline = self.f.readline()
        if configline == "" or configline == "\n":
            return ["", ""]
        else:
            configmap = configline.split("=")
            return [configmap[0], configmap[1][0:-1]]
        
    def readAllConfig(self):
        while 1:
            configline = self.f.readline()
            if configline == "" or configline == "\n":
                break
            else:
                configmap = configline.split("=")
                self.dic[configmap[0]] = configmap[1]
                
    def getConfig(key):
        return self.dic[key]    #Only use readAllConfig before
                

    def writeConfig(self, key, value):
        self.f.writelines(key + "=" + value + "\n")    
    
    def close(self):
        self.f.close()
        

class TorrentListFileManager:
    def __init__(self):
        self.filename = ""
        self.f = None
        
    def open(self, filename="torrent.lst", mode="r+"):
        self.filename = filename
        self.f = open(self.filename, mode)

    def appendList(self, filename, src, dest, status, prio, downsize, upsize):
        self.f.writelines(filename + "|" + src + "|" + dest + "|" + status + "|" + str(prio) + "|" + str(downsize) + "|" + str(upsize) + "\n")

    
    def readList(self):
        configline = self.f.readline()
        if configline == "" or configline == "\n":
            return ["", "", "", "", "", "", ""]
        else:
            configmap = configline.split("|")
            return [configmap[0], configmap[1], configmap[2], configmap[3], configmap[4], configmap[5], configmap[6][0:-1]]
    
    def close(self):
        self.f.close()
        
