from os.path import join
from os import path

class GUIManager:
    def __init__(self, abcpath):
        self.maxid = 21
        self.configdata = []
        self.numcol = 0
        self.colid = []
        self.abcpath = abcpath
        # read abc.ini
        ################
        ini = open(path.join(abcpath, "abc.ini"), "rb")
        while True:
            iniline = ini.readline()
            if iniline == "" or iniline == "\n":
                break
            iniarg = iniline.split("|")        
            self.configdata.append([ int(iniarg[0]), int(iniarg[1]), iniarg[2], int(iniarg[3][0:-1])])
            if int(iniarg[1]) != -1:
                self.numcol += 1
        ini.close()
        self.arrangeRank()

    def reloadINI(self):
        self.configdata = []
        self.numcol = 0
        self.colid = []

        ini = open(path.join(self.abcpath, "abc.ini"), "rb")
        while True:
            iniline = ini.readline()
            if iniline == "" or iniline == "\n":
                break
            iniarg = iniline.split("|")        
            self.configdata.append([ int(iniarg[0]), int(iniarg[1]), iniarg[2], int(iniarg[3][0:-1])])
            if int(iniarg[1]) != -1:
                self.numcol += 1
        ini.close()
        self.arrangeRank()
        
    def arrangeRank(self):
        for i in range(0, self.numcol):
            self.colid.append(0)
            
        for i in range(0, self.maxid):
            rank = self.configdata[i][1]
            if rank != -1:
                self.colid[rank] = self.configdata[i][0] #ID
        
    def getNumCol(self):
        return self.numcol
    
    def getRankfromID(self, id):
        return self.configdata[id][1]
            
    def getIDfromRank(self, rank):
        return self.colid[rank]
    
    def getText(self, id):
        return self.configdata[id][2]
    def getTextfromRank(self, rankid):
        return self.configdata[self.colid[rankid]][2]
    
    def getValue(self, id):
        return self.configdata[id][3]
    def getValuefromRank(self, rankid):
        return self.configdata[self.colid[rankid]][3]

