from wxPython.wx import *
from wxPython import *
from threading import Event, Thread, Semaphore
from BitTorrent.download import Download
from BitTorrent.bencode import *
from os import path, remove, getcwd
from time import time

from abcengine import ABCEngine
from filemanager import TorrentListFileManager

wxEVT_SCH = wxNewEventType()
FILESEM   = Semaphore(1)

def EVT_SCH(win, func):
    win.Connect(-1, -1, wxEVT_SCH, func)

class SchEvent(wxPyEvent):
    def __init__(self, func, args, kwargs):
        wxPyEvent.__init__(self)
        self.SetEventType(wxEVT_SCH)
        self.func = func
        self.args = args
        self.kwargs = kwargs

def runBT(params, d, doneflag):
    dow = Download ()
    d.dow = dow
    dow.download(params, d.chooseFile, d.updateStatus, d.finished, d.error, d.flag, 100, d.newpath, sem=FILESEM)#doneflag, 100, d.newpath)
    if not d.fin:
        d.failed()

# Todo: find memory leak in onPause when connecting
####################################################
class ABCScheduler(wxEvtHandler):
    def __init__(self, parent, abcparams, guiman):
        wxEvtHandler.__init__(self)
        self.LISTINDEX      = 0
        self.ABCENGINE_ADR  = 1
        self.SRC            = 2
        self.DEST           = 3
        self.STATUS         = 4
        self.PRIO           = 5
        self.DONEFLAG       = 6
        self.FILENAME       = 7
        self.MAXUPLOAD      = 8
        self.MAXUPLOADRATE  = 9
        self.UPLOADOPT      = 10
        self.UPLOADTIMEH    = 11
        self.UPLOADTIMEM    = 12
        self.UPLOADRATIO    = 13
        self.DETAIL_ADR     = 14
        self.DOWNSIZE       = 15
        self.UPSIZE         = 16

        self.maxRememberParams = 17

        self.guiman         = guiman
        self.abcparams      = abcparams
        #maxupload, maxupload_rate, upload_option O_O all option here !!

        self.priotext = ["Highest", "High", "Normal", "Low", "Lowest"]
        self.currentproc = 0
        self.parent     = parent
        self.list       = parent.list
        self.maxnumsim  = abcparams['numsimdownload']

        self.maxtorrent = 256
        self.proctab = []
        self.flag = Event()
        
        for i in range (0, self.maxtorrent):
            self.proctab.append([-1, None, "", "", "", 2, None, "",
                                 "", "", "", "", "", "", None, 0.0, 0.0])
                   #index, @abcengine,src,dest,status,priority,doneflag,filename
                   #maxupload, maxuploadrate, uploadoption, uploadtimeh,
                   #uploadtimem, uploadratio, detailwin, ratio
            
                    # index (-1) = available
                      # index (-2) = pause process
                       # priority (0 - 4), highest,high,normal, low, lowest

        EVT_SCH(self, self.onInvoke)
        
    def onInvoke(self, event):
        if not self.flag.isSet():
            event.func(*event.args, **event.kwargs)
    def invokeLater(self, func, args = [], kwargs = {}):
        if not self.flag.isSet():
            wxPostEvent(self, SchEvent(func, args, kwargs))
            
    def procREMOVE(self, index):
        indexstatus = self.proctab[index][self.LISTINDEX]
        oldstatus = self.proctab[index][self.STATUS]

        if self.abcparams['removetorrent'] == "1":
            try:
                remove(self.proctab[index][self.SRC])
            except:
                pass
            
        # Delete Detail Window
        ########################
        if self.proctab[index][self.DETAIL_ADR] is not None:
            self.proctab[index][self.DETAIL_ADR].killAdv()

        if indexstatus >= 0 :
            self.proctab[index][self.DOWNSIZE], self.proctab[index][self.UPSIZE] = self.proctab[index][self.ABCENGINE_ADR].getDownUpSize()
            self.proctab[index][self.LISTINDEX] = -1
            self.proctab[index][self.DONEFLAG] = None
            if self.proctab[index][self.ABCENGINE_ADR].timer != None:
                self.proctab[index][self.ABCENGINE_ADR].timer.cancel()
                
            self.proctab[index][self.ABCENGINE_ADR].fin = true
            self.proctab[index][self.ABCENGINE_ADR].done(None)                        
            self.proctab[index][self.ABCENGINE_ADR] = None
            if oldstatus != "completed":
                self.currentproc -= 1
            
        if index != self.maxtorrent - 1:            
            for i in range(index+1, self.maxtorrent):
                if self.proctab[i][self.LISTINDEX] == -1:
                    self.proctab[i - 1][0] = -1
                    self.proctab[i - 1][1] = None
                    self.proctab[i - 1][2] = ""
                    self.proctab[i - 1][3] = ""
                    self.proctab[i - 1][4] = ""
                    self.proctab[i - 1][5] = 2
                    self.proctab[i - 1][6] = None
                    self.proctab[i - 1][7] = ""                    
                    self.proctab[i - 1][8] = ""                    
                    self.proctab[i - 1][9] = ""                    
                    self.proctab[i - 1][10] = ""                    
                    self.proctab[i - 1][11] = ""                    
                    self.proctab[i - 1][12] = ""                    
                    self.proctab[i - 1][13] = ""                    
                    self.proctab[i - 1][14] = None  
                    self.proctab[i - 1][15] = 0.0
                    self.proctab[i - 1][16] = 0.0  
                    break

                if self.proctab[i][0] > 0:
                    self.proctab[i - 1][0] = i - 1
                else:
                    self.proctab[i - 1][0] = self.proctab[i][0] #actually it's -2                    
                self.proctab[i - 1][1] = self.proctab[i][1]
                self.proctab[i - 1][2] = self.proctab[i][2]
                self.proctab[i - 1][3] = self.proctab[i][3]
                self.proctab[i - 1][4] = self.proctab[i][4]
                self.proctab[i - 1][5] = self.proctab[i][5]
                self.proctab[i - 1][6] = self.proctab[i][6]
                self.proctab[i - 1][7] = self.proctab[i][7]
                self.proctab[i - 1][8] = self.proctab[i][8]
                self.proctab[i - 1][9] = self.proctab[i][9]
                self.proctab[i - 1][10] = self.proctab[i][10]
                self.proctab[i - 1][11] = self.proctab[i][11]
                self.proctab[i - 1][12] = self.proctab[i][12]
                self.proctab[i - 1][13] = self.proctab[i][13]
                self.proctab[i - 1][14] = self.proctab[i][14]
                self.proctab[i - 1][15] = self.proctab[i][15]
                self.proctab[i - 1][16] = self.proctab[i][16]

                if self.proctab[i-1][self.ABCENGINE_ADR] != None:                
                    self.proctab[i-1][self.ABCENGINE_ADR].changeIndex(i-1)
                    self.proctab[i-1][self.ABCENGINE_ADR].changeDoneFlag(self.proctab[i][self.DONEFLAG])
                    self.proctab[i-1][self.ABCENGINE_ADR].changePrio(self.proctab[i][self.PRIO])
                if self.proctab[i-1][self.DETAIL_ADR] != None:
                    self.proctab[i -1][self.DETAIL_ADR].changeIndex(i-1)
            
        self.proctab[self.maxtorrent - 1][0] = -1
        self.proctab[self.maxtorrent - 1][1] = None
        self.proctab[self.maxtorrent - 1][2] = ""
        self.proctab[self.maxtorrent - 1][3] = ""
        self.proctab[self.maxtorrent - 1][4] = ""
        self.proctab[self.maxtorrent - 1][5] = 2
        self.proctab[self.maxtorrent - 1][6] = None
        self.proctab[self.maxtorrent - 1][7] = ""
        self.proctab[self.maxtorrent - 1][8] = ""
        self.proctab[self.maxtorrent - 1][9] = ""
        self.proctab[self.maxtorrent - 1][10] = ""
        self.proctab[self.maxtorrent - 1][11] = ""
        self.proctab[self.maxtorrent - 1][12] = ""
        self.proctab[self.maxtorrent - 1][13] = ""
        self.proctab[self.maxtorrent - 1][14] = None
        self.proctab[self.maxtorrent - 1][15] = 0.0
        self.proctab[self.maxtorrent - 1][16] = 0.0
           
        # Send message to all ABCengine to change index
        #################################################
        self.updateTorrentList()        
        self.invokeLater(self.Scheduler)

    def procPAUSE(self, index):
        indexstatus = self.proctab[index][self.LISTINDEX]
        if indexstatus == -1:
            return
        
        oldstatus = self.proctab[index][self.STATUS]
        self.proctab[index][self.STATUS] = "pause"
        if self.proctab[index][self.DETAIL_ADR] is not None:
            self.proctab[index][self.DETAIL_ADR].onPause()


        if indexstatus != -2:
            self.proctab[index][self.DOWNSIZE], self.proctab[index][self.UPSIZE] = self.proctab[index][self.ABCENGINE_ADR].getDownUpSize()
            self.proctab[index][self.LISTINDEX] = -2
            self.proctab[index][self.DONEFLAG] = None
            if self.proctab[index][self.ABCENGINE_ADR].timer != None:
                self.proctab[index][self.ABCENGINE_ADR].timer.cancel()
            self.proctab[index][self.ABCENGINE_ADR].fin = true
            self.proctab[index][self.ABCENGINE_ADR].done(None)                        
            self.proctab[index][self.ABCENGINE_ADR] = None
            if oldstatus != "completed":
                self.currentproc -= 1

            
        self.updateTorrentList()            
        self.invokeLater(self.Scheduler)

    def procFINISH(self, index):
        indexstatus = self.proctab[index][self.LISTINDEX]
        if indexstatus == -1:
            return        

        self.proctab[index][self.STATUS] = "completed"        
        if indexstatus != -2:
            self.currentproc -= 1
            self.proctab[index][self.DOWNSIZE], self.proctab[index][self.UPSIZE] = self.proctab[index][self.ABCENGINE_ADR].getDownUpSize()
            
        self.updateTorrentList()            
        self.invokeLater(self.Scheduler)

            
    def procDONE(self, index):
        indexstatus = self.proctab[index][self.LISTINDEX]
        if indexstatus == -1:
            return        
        if self.proctab[index][self.DETAIL_ADR] is not None:
            self.proctab[index][self.DETAIL_ADR].onPause()

        if indexstatus != -2:
            self.proctab[index][self.DOWNSIZE], self.proctab[index][self.UPSIZE] = self.proctab[index][self.ABCENGINE_ADR].getDownUpSize()
            self.proctab[index][self.LISTINDEX] = -2
            self.proctab[index][self.DONEFLAG] = None
            if self.proctab[index][self.ABCENGINE_ADR].timer != None:
                self.proctab[index][self.ABCENGINE_ADR].timer.cancel()
            self.proctab[index][self.ABCENGINE_ADR].fin = true
            self.proctab[index][self.ABCENGINE_ADR].done(None)                        
            self.proctab[index][self.ABCENGINE_ADR] = None

        self.invokeLater(self.Scheduler)
        
    def procSUPERSEED(self, index):
        indexstatus = self.proctab[index][self.LISTINDEX]
        if indexstatus == -1:
            return        

        if indexstatus != -2:
            if self.proctab[index][self.STATUS] != "completed":
                #dialog your file is not completed don't use SUPERSEED
                dlg = wxMessageDialog(self.parent, "Your torrent is not completed yet, you can't use Super-Seed mode"  , "Error!!", wxICON_ERROR)
                dlg.ShowModal()
                dlg.Destroy()
            else:
                #check if super seed already run 
                if self.proctab[index][self.ABCENGINE_ADR].superseed:
                    dlg = wxMessageDialog(self.parent, "Super-seed mode is already enable"  , "Error!!", wxICON_ERROR)
                    dlg.ShowModal()
                    dlg.Destroy()
                else:
                    #dialogbox warnning after use this mode can't go back
                    dlg = wxMessageDialog(self.parent, """                
    This option greatly reduces the torrent's efficiency. 
The only people who should be using super-seed are those
doing initial seeding or re-seeding.

    Once you enable super-seed mode, you can't turn it off
unless you use "pause", "queue", "remove" operations.
                    """
                    , "Warning!!", wxOK|wxCANCEL)
                    if dlg.ShowModal() != wxID_OK:
                        return
                    else:
                        #Enter super-seed mode
                        self.proctab[index][self.ABCENGINE_ADR].superseed = true
                        if self.proctab[index][self.ABCENGINE_ADR].config is None:
                            self.proctab[index][self.ABCENGINE_ADR].config = self.proctab[index][self.ABCENGINE_ADR].dow.getConfig()
                        self.proctab[index][self.ABCENGINE_ADR].dow.set_super_seed()# one way change, don't go back
                        #change BTstatus to super-seeding
                        rank = self.guiman.getRankfromID(6) #BT status: ID=6
                        if rank != -1:
                            self.list.SetStringItem(index, rank, "super-seeding")        
                        #self.list.SetStringItem(index, 2, "super-seeding")

        else:
            #dialogbox running torrent before using super-seed mode
            dlg = wxMessageDialog(self.parent, "You must running this torrent before using Super-Seed mode"  , "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            
        
        
#    def procCANCEL(self, index):    #Call only when cancel from choosing file at first time
#        indexstatus = self.proctab[index][self.LISTINDEX]
#        if self.abcparams['removetorrent'] == "1":
#            try:
#                remove(self.proctab[index][self.SRC])
#            except:
#                pass

#        if self.proctab[index][self.DETAIL_ADR] is not None:
#            self.proctab[index][self.DETAIL_ADR].killAdv()

#        if indexstatus >= 0 :
#            self.parent.list.DeleteItem(index)
#            self.proctab[index][self.DOWNSIZE], self.proctab[index][self.UPSIZE] = self.proctab[index][self.ABCENGINE_ADR].getDownUpSize()
#            self.proctab[index][self.LISTINDEX] = -1
#            self.proctab[index][self.DONEFLAG] = None
#            if self.proctab[index][self.ABCENGINE_ADR].timer != None:
#                self.proctab[index][self.ABCENGINE_ADR].timer.cancel()
#            self.proctab[index][self.ABCENGINE_ADR].fin = true
#            self.proctab[index][self.ABCENGINE_ADR].done(None)                        
#            self.proctab[index][self.ABCENGINE_ADR] = None
            
#        if index != self.maxtorrent - 1:            
#            for i in range(index+1, self.maxtorrent):
#                if self.proctab[i][self.LISTINDEX] == -1:
#                    self.proctab[i - 1][0] = -1
#                    self.proctab[i - 1][1] = None
#                    self.proctab[i - 1][2] = ""
#                    self.proctab[i - 1][3] = ""
#                    self.proctab[i - 1][4] = ""
#                    self.proctab[i - 1][5] = 2
#                    self.proctab[i - 1][6] = None
#                    self.proctab[i - 1][7] = ""                    
#                    self.proctab[i - 1][8] = ""                    
#                    self.proctab[i - 1][9] = ""                    
#                    self.proctab[i - 1][10] = ""                    
#                    self.proctab[i - 1][11] = ""                    
#                    self.proctab[i - 1][12] = ""                    
#                    self.proctab[i - 1][13] = ""                    
#                    self.proctab[i - 1][14] = None
#                    self.proctab[i - 1][15] = 0.0
#                    self.proctab[i - 1][16] = 0.0

#                    break
                
#                if self.proctab[i][0] > 0:
#                    self.proctab[i - 1][0] = i - 1
#                else:
#                    self.proctab[i - 1][0] = self.proctab[i][0] #actually it's -2
#                    
#                self.proctab[i - 1][1] = self.proctab[i][1]
#                self.proctab[i - 1][2] = self.proctab[i][2]
#                self.proctab[i - 1][3] = self.proctab[i][3]
#                self.proctab[i - 1][4] = self.proctab[i][4]
#                self.proctab[i - 1][5] = self.proctab[i][5]
#                self.proctab[i - 1][6] = self.proctab[i][6]
#                self.proctab[i - 1][7] = self.proctab[i][7]
#                self.proctab[i - 1][8] = self.proctab[i][8]
#                self.proctab[i - 1][9] = self.proctab[i][9]
#                self.proctab[i - 1][10] = self.proctab[i][10]
#                self.proctab[i - 1][11] = self.proctab[i][11]
#                self.proctab[i - 1][12] = self.proctab[i][12]
#                self.proctab[i - 1][13] = self.proctab[i][13]
#                self.proctab[i - 1][14] = self.proctab[i][14]
#                self.proctab[i - 1][15] = self.proctab[i][15]
#                self.proctab[i - 1][16] = self.proctab[i][16]

#                if self.proctab[i - 1][self.ABCENGINE_ADR] != None:
#                    self.proctab[i - 1][self.ABCENGINE_ADR].changeIndex(i - 1)
#                    self.proctab[i - 1][self.ABCENGINE_ADR].changeDoneFlag(self.proctab[i][self.DONEFLAG])
#                    self.proctab[i - 1][self.ABCENGINE_ADR].changePrio(self.proctab[i][self.PRIO])
#                            
#        self.proctab[self.maxtorrent - 1][0] = -1
#        self.proctab[self.maxtorrent - 1][1] = None
#        self.proctab[self.maxtorrent - 1][2] = ""
#        self.proctab[self.maxtorrent - 1][3] = ""
#        self.proctab[self.maxtorrent - 1][4] = ""
#        self.proctab[self.maxtorrent - 1][5] = 2
#        self.proctab[self.maxtorrent - 1][6] = None
#        self.proctab[self.maxtorrent - 1][7] = ""
#        self.proctab[self.maxtorrent - 1][8] = ""
#        self.proctab[self.maxtorrent - 1][9] = ""
#        self.proctab[self.maxtorrent - 1][10] = ""
#        self.proctab[self.maxtorrent - 1][11] = ""
#        self.proctab[self.maxtorrent - 1][12] = ""
#        self.proctab[self.maxtorrent - 1][13] = ""
#        self.proctab[self.maxtorrent - 1][14] = None
#        self.proctab[self.maxtorrent - 1][15] = 0.0
#        self.proctab[self.maxtorrent - 1][16] = 0.0

       # self.updateTorrentList()
       # self.invokeLater(self.Scheduler)

        
    def procRESUME(self, index):
        indexstatus = self.proctab[index][self.LISTINDEX]
        if indexstatus != -2:   #ignore resume active process     
            return

        self.proctab[index][self.STATUS] = "queue"
        self.updateTorrentList()        
        self.currentproc += 1
        self.runProc(index, 0) 

        #self.invokeLater(self.Scheduler) don't need scheduler


    def procQUEUE(self, index, firsttime_flag):
        indexstatus = self.proctab[index][self.LISTINDEX]
        if indexstatus == -1:
            return
        if self.proctab[index][self.DETAIL_ADR] is not None:
            self.proctab[index][self.DETAIL_ADR].onPause()

        oldstatus = self.proctab[index][self.STATUS]
        self.proctab[index][self.STATUS] = "queue"

        if indexstatus != -2:
            self.proctab[index][self.DOWNSIZE], self.proctab[index][self.UPSIZE] = self.proctab[index][self.ABCENGINE_ADR].getDownUpSize()
            self.proctab[index][self.LISTINDEX] = -2
            self.proctab[index][self.DONEFLAG] = None
            if self.proctab[index][self.ABCENGINE_ADR].timer != None:
                self.proctab[index][self.ABCENGINE_ADR].timer.cancel()

            self.proctab[index][self.ABCENGINE_ADR].fin = true
            self.proctab[index][self.ABCENGINE_ADR].done(None)                        
            self.proctab[index][self.ABCENGINE_ADR] = None

            if oldstatus != "completed" and firsttime_flag == 0:
                self.currentproc -= 1

        self.updateTorrentList()        
        self.invokeLater(self.Scheduler)

            
    def addNewProc(self, src, forceasklocation): #from 3 sources, add from file, add from URL, autoadd
                      #from file, URL maybe down torrent.lst from addProc
                      # change at onChooseFile make sure they choose dest
        try:
            metainfo_file = open(src, 'rb')
            metainfo = bdecode(metainfo_file.read())
            metainfo_file.close()
            info = metainfo['info']
        except :
            metainfo_file.close()            
            dlg = wxMessageDialog(self.parent, "Failed : Invalid torrent file." , "Error!!", wxICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            try:
                remove(src)
            except:
                pass
            return

        # No default directory
        if self.abcparams['setdefaultfolder'] == '0' or forceasklocation:
            if info.has_key('length'):   #1 file for this torrent
                dl = wxFileDialog(self.parent, 'Choose file to save as, pick a partial download to resume (%.1f MB)'%(info['length']/(1<<20)), '', info['name'], '*.*', wxSAVE)
            else:   # Directory torrent
                file_length = 0
                for x in info['files']:
                    file_length += x['length']                
                dl = wxDirDialog(self.parent, 'Choose a directory to save to, pick a partial download to resume (%.1f MB)'%(file_length/(1<<20)), path.join(getcwd(), info['name']), style = wxDD_DEFAULT_STYLE | wxDD_NEW_DIR_BUTTON)
            if dl.ShowModal() != wxID_OK:
                if self.abcparams['removetorrent'] == "1":
                    try:
                        remove(src)
                    except:
                        pass
                return
            else:
                getslot = 0        
                for i in range(0, self.maxtorrent):
                    if self.proctab[i][self.LISTINDEX] == -1:
                        self.proctab[i][self.LISTINDEX] = -2   # set queue status
                        self.proctab[i][self.ABCENGINE_ADR] = None       # @ ABCEngine
                        self.proctab[i][self.SRC] = src        # .torrent source file
                
                        self.proctab[i][self.DEST] = dl.GetPath()      # destination download file
                    
                        self.proctab[i][self.STATUS] = "queue"
                        self.proctab[i][self.PRIO] = 2          # Priority "Normal"
                        self.proctab[i][self.DONEFLAG] = None       # Done flag
                        self.proctab[i][self.FILENAME] = info['name']
                        self.proctab[i][self.MAXUPLOAD]     = self.abcparams['maxupload']
                        self.proctab[i][self.MAXUPLOADRATE] = self.abcparams['maxuploadrate']
                        self.proctab[i][self.UPLOADOPT]     = self.abcparams['uploadoption']
                        self.proctab[i][self.UPLOADTIMEH]   = self.abcparams['uploadtimeh']
                        self.proctab[i][self.UPLOADTIMEM]   = self.abcparams['uploadtimem']
                        self.proctab[i][self.UPLOADRATIO]   = self.abcparams['uploadratio']
                        self.proctab[i][self.DETAIL_ADR]    = None
                        self.proctab[i][self.DOWNSIZE]      = 0.0
                        self.proctab[i][self.UPSIZE]        = 0.0

                        getslot = 1
                        numslot = i
                        break
                if getslot == 0:
                    return        
                self.parent.list.InsertStringItem(numslot, "")
                #Add Status info in List
                for rank in range(0, self.guiman.getNumCol()):
                    colid = self.guiman.getIDfromRank(rank)
                    if colid == 4:
                        self.parent.list.SetStringItem(numslot, rank, self.proctab[numslot][self.FILENAME])
                    elif colid == 6:
                        self.parent.list.SetStringItem(numslot, rank, "queue")
                    elif colid == 7:
                        self.parent.list.SetStringItem(numslot, rank, self.priotext[self.proctab[numslot][self.PRIO]])
                    else:
                        self.parent.list.SetStringItem(numslot, rank, "")

                self.updateTorrentList()
                self.Scheduler()

        else:
            getslot = 0        
            for i in range(0, self.maxtorrent):
                if self.proctab[i][self.LISTINDEX] == -1:
                    self.proctab[i][self.LISTINDEX] = -2   # set queue status
                    self.proctab[i][self.ABCENGINE_ADR] = None       # @ ABCEngine
                    self.proctab[i][self.SRC] = src        # .torrent source file                
                    self.proctab[i][self.DEST] = path.join(self.abcparams['defaultfolder'], info['name'])
                    self.proctab[i][self.STATUS] = "queue"
                    self.proctab[i][self.PRIO] = 2          # Priority "Normal"
                    self.proctab[i][self.DONEFLAG] = None       # Done flag
                    self.proctab[i][self.FILENAME] = info['name']
                    self.proctab[i][self.MAXUPLOAD]     = self.abcparams['maxupload']
                    self.proctab[i][self.MAXUPLOADRATE] = self.abcparams['maxuploadrate']
                    self.proctab[i][self.UPLOADOPT]     = self.abcparams['uploadoption']
                    self.proctab[i][self.UPLOADTIMEH]   = self.abcparams['uploadtimeh']
                    self.proctab[i][self.UPLOADTIMEM]   = self.abcparams['uploadtimem']
                    self.proctab[i][self.UPLOADRATIO]   = self.abcparams['uploadratio']
                    self.proctab[i][self.DETAIL_ADR]    = None
                    self.proctab[i][self.DOWNSIZE]      = 0.0
                    self.proctab[i][self.UPSIZE]        = 0.0

                    getslot = 1
                    numslot = i
                    break
            if getslot == 0:
                return        
            self.parent.list.InsertStringItem(numslot, "")
            #Add Status info in List
            for rank in range(0, self.guiman.getNumCol()):
                colid = self.guiman.getIDfromRank(rank)
                if colid == 4:
                    self.parent.list.SetStringItem(numslot, rank, self.proctab[numslot][self.FILENAME])
                elif colid == 6:
                    self.parent.list.SetStringItem(numslot, rank, "queue")
                elif colid == 7:
                    self.parent.list.SetStringItem(numslot, rank, self.priotext[self.proctab[numslot][self.PRIO]])
                else:
                    self.parent.list.SetStringItem(numslot, rank, "")

            self.updateTorrentList()
            self.Scheduler()
        
    def addOldProc(self, oldproc_array):

        numproc = len(oldproc_array)
        for i in range(0, numproc):
            #if self.proctab[i][self.LISTINDEX] == -1:
                self.proctab[i][self.LISTINDEX]     = -2    
                self.proctab[i][self.ABCENGINE_ADR] = None  
                self.proctab[i][self.SRC]           = oldproc_array[i][1]
                self.proctab[i][self.DEST]          = oldproc_array[i][2]
                self.proctab[i][self.STATUS]        = oldproc_array[i][3]
                self.proctab[i][self.PRIO]          = int(oldproc_array[i][4])
                self.proctab[i][self.DONEFLAG]      = None 
                self.proctab[i][self.FILENAME]      = oldproc_array[i][0]
                self.proctab[i][self.MAXUPLOAD]     = self.abcparams['maxupload']
                self.proctab[i][self.MAXUPLOADRATE] = self.abcparams['maxuploadrate']
                self.proctab[i][self.UPLOADOPT]     = self.abcparams['uploadoption']
                self.proctab[i][self.UPLOADTIMEH]   = self.abcparams['uploadtimeh']
                self.proctab[i][self.UPLOADTIMEM]   = self.abcparams['uploadtimem']
                self.proctab[i][self.UPLOADRATIO]   = self.abcparams['uploadratio']
                self.proctab[i][self.DETAIL_ADR]    = None
                self.proctab[i][self.DOWNSIZE]      = float(oldproc_array[i][5])
                self.proctab[i][self.UPSIZE]        = float(oldproc_array[i][6])
                        
                self.parent.list.InsertStringItem(i, "")
                
                for rank in range(0, self.guiman.getNumCol()):
                    colid = self.guiman.getIDfromRank(rank)
                    if colid   == 4:        # Title column
                        self.list.SetStringItem(i, rank, self.proctab[i][self.FILENAME])
                    elif colid == 6:        # BT status column
                        self.list.SetStringItem(i, rank, self.proctab[i][self.STATUS])
                    elif colid == 7:
                        self.list.SetStringItem(i, rank, self.priotext[self.proctab[i][self.PRIO]])
                    elif colid == 12:
                        if int(self.proctab[i][self.DOWNSIZE]) == 0 :
                            self.list.SetStringItem(i, rank, 'oo %')
                        else:
                            self.list.SetStringItem(i, rank, '%.1f'%((self.proctab[i][self.UPSIZE]/self.proctab[i][self.DOWNSIZE])*100) + "%")
                    elif colid == 18:
                        self.list.SetStringItem(i, rank, ('%.2f MB' % (self.proctab[i][self.DOWNSIZE] / (1 << 20))))
                    elif colid == 19:
                        self.list.SetStringItem(i, rank, ('%.2f MB' % (self.proctab[i][self.UPSIZE] / (1 << 20))))                        
                    else:                        
                        self.list.SetStringItem(i, rank, "")
                        
                #self.list.SetStringItem(i, 0, self.proctab[i][self.FILENAME])
                #self.list.SetStringItem(i, 1, "")
                #self.list.SetStringItem(i, 2, self.proctab[i][self.STATUS])
                #self.list.SetStringItem(i, 3, self.priotext[self.proctab[i][self.PRIO]])
                #self.list.SetStringItem(i, 4, "")
                #self.list.SetStringItem(i, 5, "")
                #self.list.SetStringItem(i, 6, "")
                #self.list.SetStringItem(i, 7, "")
                #self.list.SetStringItem(i, 8, "")        

        self.invokeLater(self.Scheduler)                

    def runProc(self, index, firsttime_flag):
        self.proctab[index][self.DONEFLAG] = Event()
        self.proctab[index][self.LISTINDEX] = index
        self.proctab[index][self.STATUS] = "working"
        self.proctab[index][self.ABCENGINE_ADR] = ABCEngine(self, index, firsttime_flag,
                                                            self.proctab[index][self.DONEFLAG],
                                                            self.proctab[index][self.PRIO],
                                                            self.guiman,
                                                            self.proctab[index][self.DOWNSIZE],
                                                            self.proctab[index][self.UPSIZE]
                                                            )
        # Construct BT params
        ###########################
        btparams = []
        btparams.append("--responsefile")
        btparams.append(self.proctab[index][self.SRC])
        btparams.append("--minport")
        btparams.append(self.abcparams['minport'])
        btparams.append("--maxport")
        btparams.append(self.abcparams['maxport'])
        btparams.append("--max_uploads")
        btparams.append(self.proctab[index][self.MAXUPLOAD])
        btparams.append("--min_uploads")
        btparams.append(self.proctab[index][self.MAXUPLOAD])

        if self.abcparams['ip'] != '':
            btparams.append("--ip")
            btparams.append(self.abcparams['ip'])
        if self.abcparams['bind'] != '':
            btparams.append("--bind")
            btparams.append(self.abcparams['bind'])

        btparams.append("--min_peers")
        btparams.append(self.abcparams['min_peers'])
        btparams.append("--alloc_type")
        btparams.append(self.abcparams['alloc_type'])
        btparams.append("--alloc_rate")
        btparams.append(self.abcparams['alloc_rate'])
        btparams.append("--max_files_open")
        btparams.append(self.abcparams['max_files_open'])
        btparams.append("--max_connections")
        btparams.append(self.abcparams['max_connections'])

        btparams.append("--max_upload_rate")
        max_upload_rate = int(self.proctab[index][self.MAXUPLOADRATE])
        # if someone cheat by edit abc.conf to less than 3 kb/s
        # make it to unlimited !!! *devil* :D
        if max_upload_rate != 0 and max_upload_rate < 3:
            btparams.append(str("0"))
        else:        
            btparams.append(self.proctab[index][self.MAXUPLOADRATE])
        
        btparams.append("--max_initiate")
        nummaxupload = int(self.proctab[index][self.MAXUPLOAD])
        if nummaxupload < 4 :
            btparams.append(str(min(12, int(self.abcparams['max_initiate']))))
        elif nummaxupload < 30:
            btparams.append(str(min(40, int(self.abcparams['max_initiate']))))
        else:
            btparams.append(str(min(nummaxupload+10, int(self.abcparams['max_initiate']))))
        
        if self.proctab[index][3] != "":
            btparams.append("--saveas")
            btparams.append(self.proctab[index][self.DEST])

        for rank in range(0, self.parent.guiman.getNumCol()):
            ID = self.parent.guiman.getIDfromRank(rank)
            if ID == 6:   
                self.list.SetStringItem(index, rank, "Waiting..")
            
        thread = Thread(target = runBT, args = [btparams, self.proctab[index][self.ABCENGINE_ADR],
                                               self.proctab[index][self.DONEFLAG]])
        thread.setDaemon(false)
        thread.start()

    def changeDEST(self, index, dest):
        self.proctab[index][self.DEST] = dest
        
    def changePriority(self, index, prio):        
        self.proctab[index][self.PRIO] = prio
        if self.proctab[index][self.LISTINDEX] != -2:
            self.proctab[index][self.ABCENGINE_ADR].changePrio(prio)
            
    def getPriority(self, index):
        return self.proctab[index][self.PRIO]
        
    def changeSTATUS(self, index, status):
        self.proctab[index][self.STATUS] = status
        
    def changeFILENAME(self, index, filename):
        self.proctab[index][self.FILENAME] = filename
        
    def updateTorrentList(self):
            torrentlist = TorrentListFileManager()
            torrentlist.open(path.join(self.parent.abcpath, "torrent.lst"), "w")
            for i in range(0, self.maxtorrent):
                if self.proctab[i][self.LISTINDEX] == -1:
                    break
                if self.proctab[i][self.FILENAME] == "":
                    continue
                
                status = self.proctab[i][self.STATUS]
                if status == "working":
                    status = "queue"
                torrentlist.appendList(self.proctab[i][self.FILENAME],
                                       self.proctab[i][self.SRC],
                                       self.proctab[i][self.DEST],
                                       status,
                                       self.proctab[i][self.PRIO],
                                       self.proctab[i][self.DOWNSIZE],
                                       self.proctab[i][self.UPSIZE])
            torrentlist.close()
        
        
    def Scheduler(self):
        if self.currentproc >= int(self.maxnumsim):
            return
        # Choose job by highest priority
        #################################
        for priority in range(0, 5):
            done = 0
            for i in range(0, self.maxtorrent):
                if self.proctab[i][self.LISTINDEX] == -1:
                    break
                if self.proctab[i][self.PRIO] != priority:
                    continue
                
                if self.proctab[i][self.STATUS] == "queue" and self.currentproc < int(self.maxnumsim):
                   self.runProc(i, 0) #it will run before close :-\
                   self.currentproc += 1
                   if self.currentproc >= int(self.maxnumsim):
                       done = 1
                       break
            if (done):
                break        


    def getLocalInfo(self, index):
        return ([self.proctab[index][self.MAXUPLOAD],  self.proctab[index][self.MAXUPLOADRATE],
                self.proctab[index][self.UPLOADOPT],   self.proctab[index][self.UPLOADTIMEH],
                self.proctab[index][self.UPLOADTIMEM], self.proctab[index][self.UPLOADRATIO]])

                
    def changeLocalInfo(self, index, info):
        if self.proctab[index][self.LISTINDEX] == -1:
            return
        self.proctab[index][self.MAXUPLOAD]     = info[0]
        self.proctab[index][self.MAXUPLOADRATE] = info[1]
        if self.proctab[index][self.LISTINDEX] == -2 or self.proctab[index][self.STATUS] != "completed" :
            self.proctab[index][self.UPLOADOPT]     = info[2]
        self.proctab[index][self.UPLOADTIMEH]   = info[3]
        self.proctab[index][self.UPLOADTIMEM]   = info[4]
        self.proctab[index][self.UPLOADRATIO]   = info[5]
        
        if self.proctab[index][self.LISTINDEX] != -2:   #active process
            if self.proctab[index][self.ABCENGINE_ADR].config is None:
                self.proctab[index][self.ABCENGINE_ADR].config = self.proctab[index][self.ABCENGINE_ADR].dow.getConfig()
            self.proctab[index][self.ABCENGINE_ADR].config['max_upload_rate'] = int(info[1]) * 1000
            nummaxupload = int(info[0])
            self.proctab[index][self.ABCENGINE_ADR].config['max_uploads']  = nummaxupload
            self.proctab[index][self.ABCENGINE_ADR].config['min_uploads'] = nummaxupload
            self.proctab[index][self.ABCENGINE_ADR].dow.setUploadRate()

            if nummaxupload < 4:                
                self.proctab[index][self.ABCENGINE_ADR].config['max_initiate'] = 12
            elif nummaxupload < 30:
                self.proctab[index][self.ABCENGINE_ADR].config['max_initiate'] = 40
            else:
                self.proctab[index][self.ABCENGINE_ADR].config['max_initiate'] = nummaxupload+10
        
    def changeABCParams(self, abcparams):
        self.abcparams = abcparams
        self.maxnumsim = self.abcparams['numsimdownload']
        for i in range(0, self.maxtorrent):
            if self.proctab[i][self.LISTINDEX] == -1:
                break
            self.proctab[i][self.MAXUPLOAD]     = self.abcparams['maxupload']
            self.proctab[i][self.MAXUPLOADRATE] = self.abcparams['maxuploadrate']

            if self.proctab[i][self.LISTINDEX] == -2 or self.proctab[i][self.STATUS] != "completed" :    
                self.proctab[i][self.UPLOADOPT]     = self.abcparams['uploadoption']
            self.proctab[i][self.UPLOADTIMEH]   = self.abcparams['uploadtimeh']
            self.proctab[i][self.UPLOADTIMEM]   = self.abcparams['uploadtimem']
            self.proctab[i][self.UPLOADRATIO]   = self.abcparams['uploadratio']

            if self.proctab[i][self.LISTINDEX] != -2:
                if self.proctab[i][self.ABCENGINE_ADR].config is None:
                    self.proctab[i][self.ABCENGINE_ADR].config = self.proctab[i][self.ABCENGINE_ADR].dow.getConfig()
                self.proctab[i][self.ABCENGINE_ADR].config['max_upload_rate'] = int(self.abcparams['maxuploadrate']) * 1000
                self.proctab[i][self.ABCENGINE_ADR].dow.setUploadRate()
                
                nummaxupload = int(self.abcparams['maxupload'])
                self.proctab[i][self.ABCENGINE_ADR].config['max_uploads'] = nummaxupload
                self.proctab[i][self.ABCENGINE_ADR].config['min_uploads'] = nummaxupload

                if nummaxupload < 4:
                    self.proctab[i][self.ABCENGINE_ADR].config['max_initiate'] = min(12, self.abcparams['max_initiate'])
                elif nummaxupload < 30:
                    self.proctab[i][self.ABCENGINE_ADR].config['max_initiate'] = min(40, self.abcparams['max_initiate'])
                else:
                    self.proctab[i][self.ABCENGINE_ADR].config['max_initiate'] = min(nummaxupload+10, self.abcparams['max_initiate'])
                    
                
        self.invokeLater(self.Scheduler)
        
    def hasDetailWin(self, index):
        if self.proctab[index][self.DETAIL_ADR] is None:
            return false
        else:
            return true
    def deleteDetailWin(self, index):
        try:
            self.proctab[index][self.DETAIL_ADR] = None
        except wxPyDeadObjectError, e:
            self.proctab[index][self.DETAIL_ADR] = None
            
    def reannounce(self, index, arg=""):
        # if torrent is not running.. can't reannounce
        if self.proctab[index][self.LISTINDEX] < 0:
            return
        else:
            if (time() - self.proctab[index][self.ABCENGINE_ADR].reannouncelast > 60):
                self.proctab[index][self.ABCENGINE_ADR].reannouncelast = time()
                if arg == "":
                    self.proctab[index][self.ABCENGINE_ADR].dow.reannounce()
                else:
                    self.proctab[index][self.ABCENGINE_ADR].dow.reannounce(arg)

    def getlastexternalannounce(self, index):
        if self.proctab[index][self.LISTINDEX] < 0:
            return ''
        else:
            return self.proctab[index][self.ABCENGINE_ADR].lastexternalannounce

    def setlastexternalannounce(self, index, exannounce):
        if self.proctab[index][self.LISTINDEX] < 0:
            return
        else:
            self.proctab[index][self.ABCENGINE_ADR].lastexternalannounce = exannounce

        
    def bgalloc(self, index):
        if self.proctab[index][self.LISTINDEX] < 0:
            return
        else:
            if self.proctab[index][self.ABCENGINE_ADR].dow.storagewrapper is not None:
                self.proctab[index][self.ABCENGINE_ADR].dow.storagewrapper.bgalloc()

    def getResponse(self, index):
        if self.proctab[index][self.LISTINDEX] == -1:
            return None
        elif self.proctab[index][self.LISTINDEX] == -2:
            #not active process
            metainfo_file = open(self.proctab[index][self.SRC], 'rb')
            metainfo = bdecode(metainfo_file.read())
            metainfo_file.close()
            return metainfo
        else:
            #ative process
            metainfo = self.proctab[index][self.ABCENGINE_ADR].dow.getResponse()
            if metainfo == None:
                metainfo_file = open(self.proctab[index][self.SRC], 'rb')
                metainfo = bdecode(metainfo_file.read())
                metainfo_file.close()
            return metainfo
        
    def SwapListIndex(self, index1, index2):
        tempdata = []
        tempdata.append([-1, None, "", "", "", 2, None, "", "", "", "", "", "", "", None, 0.0, 0.0])

        for i in range(0, self.maxRememberParams):  
            tempdata[0][i] = self.proctab[index1][i]
        
        # Swap all data 
        for i in range(0, self.maxRememberParams): 
            self.proctab[index1][i] = self.proctab[index2][i]
            self.proctab[index2][i] = tempdata[0][i]
        
        # Change ID
        if self.proctab[index1][self.LISTINDEX] >= 0:
            self.proctab[index1][self.LISTINDEX] = index1
        if self.proctab[index2][self.LISTINDEX] >= 0:
            self.proctab[index2][self.LISTINDEX] = index2
            
        # Update Display List
        tempdata = []
        for rank in range(0, self.guiman.getNumCol()):          
            tempdata.append(self.list.GetItem(index1, rank).GetText())
            
        for rank in range(0, self.guiman.getNumCol()):
            self.list.SetStringItem(index1, rank, self.list.GetItem(index2, rank).GetText())
            self.list.SetStringItem(index2, rank, tempdata[rank])

        # Change Index in ABCEngine, ABCDetail_Win,(doneflag, prio)??
        if self.proctab[index1][self.ABCENGINE_ADR] != None:                
            self.proctab[index1][self.ABCENGINE_ADR].changeIndex(self.proctab[index1][self.LISTINDEX])
            self.proctab[index1][self.ABCENGINE_ADR].changeDoneFlag(self.proctab[index1][self.DONEFLAG])
            self.proctab[index1][self.ABCENGINE_ADR].changePrio(self.proctab[index1][self.PRIO])
            if self.proctab[index1][self.DETAIL_ADR] != None:
                    self.proctab[index1][self.DETAIL_ADR].changeIndex(index1)
                    
        if self.proctab[index2][self.ABCENGINE_ADR] != None:                
            self.proctab[index2][self.ABCENGINE_ADR].changeIndex(self.proctab[index2][self.LISTINDEX])
            self.proctab[index2][self.ABCENGINE_ADR].changeDoneFlag(self.proctab[index2][self.DONEFLAG])
            self.proctab[index2][self.ABCENGINE_ADR].changePrio(self.proctab[index2][self.PRIO])
            if self.proctab[index2][self.DETAIL_ADR] != None:
                    self.proctab[index2][self.DETAIL_ADR].changeIndex(index2)

        self.updateTorrentList()            
        self.invokeLater(self.Scheduler)


    def MoveItemUp(self, index):
        if index == 0:       # First Item can't move up anymore
            return False
        if self.proctab[index - 1][self.LISTINDEX] == -1: #just protect
            return False
        self.SwapListIndex(index, index -1)
        return True
        
    def MoveItemDown(self, index):
        if self.proctab[index + 1][self.LISTINDEX] == -1 : #Last Item can't move down anymore
            return false
        self.SwapListIndex(index, index+1)
        return true
        
    def clearAllCompleted(self):
        index = 0
        while True:
            if self.proctab[index][self.LISTINDEX] == -1:
                break
            if self.proctab[index][self.LISTINDEX] == -2 and self.proctab[index][self.STATUS] == "completed":
                self.list.DeleteItem(index)
                self.procREMOVE(index)
            else:
                index += 1
                
    def updateInactiveCol(self):
        for i in range(0, self.maxtorrent):
            if self.proctab[i][self.LISTINDEX] == -1:
                break
            if self.proctab[i][self.LISTINDEX] == -2:   #Inactive torrent
                # Display only title, BT status, Priority, %U/D SIZE, down,upsize
                #####################################################
                for rank in range(0, self.parent.guiman.getNumCol()):
                    ID = self.parent.guiman.getIDfromRank(rank)
                    if ID == 4:     # Title
                        self.list.SetStringItem(i, rank, self.proctab[i][self.FILENAME])
                    elif ID == 6:   #BT status
                        self.list.SetStringItem(i, rank, self.proctab[i][self.STATUS])
                    elif ID == 7:   #Priority
                        self.list.SetStringItem(i, rank, self.priotext[self.proctab[i][self.PRIO]])
                    elif ID == 12:  # %U/D Size
                        if int(self.proctab[i][self.DOWNSIZE]) == 0 :
                            self.list.SetStringItem(i, rank, 'oo %')
                        else:
                            self.list.SetStringItem(i, rank, '%.1f'%((self.proctab[i][self.UPSIZE]/self.proctab[i][self.DOWNSIZE])*100) + "%")
                    elif ID == 18:
                        self.list.SetStringItem(i, rank, ('%.2f MB' % (self.proctab[i][self.DOWNSIZE] / (1 << 20))))
                    elif ID == 19:
                        self.list.SetStringItem(i, rank, ('%.2f MB' % (self.proctab[i][self.UPSIZE] / (1 << 20))))                        
                    else:
                        self.list.SetStringItem(i, rank, '')
            else: # only BT status
                for rank in range(0, self.parent.guiman.getNumCol()):
                    ID = self.parent.guiman.getIDfromRank(rank)
                    if ID == 6:   #BT status
                        self.list.SetStringItem(i, rank, "Waiting..")
        
    def SetDetailWinSize(self, whsize):
        for i in range(0, self.maxtorrent):
            if self.proctab[i][self.LISTINDEX] == -1:
                break
            if self.proctab[i][self.DETAIL_ADR] is not None:
                self.proctab[i][self.DETAIL_ADR].SetSize(whsize)
            
    def clearScheduler(self):
        for i in range(0, self.maxtorrent):
            if self.proctab[i][self.LISTINDEX] == -1:
                break
            
            self.proctab[i][self.DONEFLAG] = None
            if self.proctab[i][self.ABCENGINE_ADR] is not None:
                self.proctab[i][self.DOWNSIZE], self.proctab[i][self.UPSIZE] = self.proctab[i][self.ABCENGINE_ADR].getDownUpSize()
                self.proctab[i][self.ABCENGINE_ADR].fin = true
                self.proctab[i][self.ABCENGINE_ADR].done(None)                        
                self.proctab[i][self.ABCENGINE_ADR] = None
            if self.proctab[i][self.DETAIL_ADR] is not None:
                self.proctab[i][self.DETAIL_ADR].killAdv()                

        self.updateTorrentList()

    def isProcActive(self, index):
        if(self.proctab[index][self.LISTINDEX] >= 0):
            return True
        else:
            return False
    def isProcComplete(self, index):
        if(self.proctab[index][self.STATUS] == "completed"):
            return True
        else:
            return False
    def getProcDest(self, index):
        torrentfile, name = self.isFile(index)
        if torrentfile:
            return self.proctab[index][self.DEST]
        else:
            return (self.proctab[index][self.DEST]+name)

    def isFile(self, index):
        metainfo_file = open(self.proctab[index][self.SRC], 'rb')
        metainfo = bdecode(metainfo_file.read())
        metainfo_file.close()
        info = metainfo['info']
        if info.has_key('length'):
            return True, info['name']
        else:
            return False, info['name']
        
    def changeProcDest(self, index, dest):
        self.proctab[index][self.DEST] = dest
        self.updateTorrentList()
        
    def getLastScrape(self, index):
        return self.proctab[index][self.ABCENGINE_ADR].lastgetscrape
    
    def updateScrapeData(self, index, newpeer, newseed):
        self.proctab[index][self.ABCENGINE_ADR].lastgetscrape = time()
        self.proctab[index][self.ABCENGINE_ADR].currentpeer = newpeer
        self.proctab[index][self.ABCENGINE_ADR].currentseed = newseed
